package com.at.video

import android.os.Build
import android.webkit.WebView
import com.at.common.BaseApplication
import com.at.common.global.CacheHelper
import com.at.common.global.Constants
import com.jeremyliao.liveeventbus.LiveEventBus
import com.melancholy.utils.AppUtils
import dagger.hilt.android.HiltAndroidApp

/**
 * @Create_time: 2022/4/20 20:08
 * @Description: 全局Application
 */
@HiltAndroidApp
class GlobalApplication : BaseApplication() {

    override fun onCreate() {
        val spiltStr = if (BuildConfig.BASE_URL.contains(",")) "," else "\n"
        val urls = BuildConfig.BASE_URL.split(spiltStr)
        Constants.BASE_URLS = urls.toTypedArray()
        val url = if (urls[0].endsWith("/")) urls[0] else "${urls[0]}/"
        Constants.BASE_URL = url
        Constants.APP_NAME = BuildConfig.APP_NAME
        CacheHelper.getInstance().putString(Constants.KEY_DATA_3, url)
        val cacheUrls = CacheHelper.getInstance().getString(AppUtils.getPackageName(this), "")
        if (!cacheUrls.isNullOrEmpty()) {
            Constants.BASE_URL = cacheUrls.split(",")[0]
        }
        Constants.IS_DEBUG = BuildConfig.DEBUG
        Constants.APP_ID = BuildConfig.APP_ID.toString()
//        Constants.USER_ID = BuildConfig.USER_ID
//        Constants.URL_PATH_SUFFIX = "v1/app/"
        super.onCreate()
        initWebView()
        LiveEventBus
            .config()
            .autoClear(true)
            .lifecycleObserverAlwaysActive(true)
    }

    private fun initWebView() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.P) {
            val processName = getProcessName()
            WebView.setDataDirectorySuffix(processName)
        }
    }
}
