package com.at.video.atlas

import java.math.RoundingMode
import java.text.DecimalFormat

/**
 * @description:
 * @author:  stone
 * @email: 转化
 * @date :   2022/6/21 下午2:10
 */
fun Int.hot2String(hint: String = ""):String{
    return if (this < 10000) {
        "${this}${hint}"
    } else {//保留两位小数
        "${(this / 10000f).getFloatNoMoreThanTwoDigits()}万${hint}"
    }
}

//保留一位小数
fun Float.getFloatNoMoreThanTwoDigits(): String {
    val format = DecimalFormat("#.#")
    //舍弃规则，RoundingMode.FLOOR表示直接舍弃。
    format.roundingMode = RoundingMode.FLOOR
    return format.format(this)
}