package com.at.video.atlas.entity

import com.chad.library.adapter.base.entity.MultiItemEntity
import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class PictureBean(
    val id: String?,
    val name: String?,
    val categ_id: String?,
    val categ_name: String?,
    val subcateg_id: String?,
    val subcateg_name: String?,
    val publish_status:Int = 0,
    val price: String?,
    val price_type: Int = 1,
    val author:String?,
    val status: Int =0,
    val introduction:String?,
    val cover_vertical:String?,
    val cover_horizontal:String?,
    val origin:Int = 0,
    val chapter_count:String?,
    val picture_count:String?,
    val popularity: String?,
    val tags:String?,
    val keywords:String?,
    val site_id:String?,
    val created_at:String?,
    val updated_at: String?,
    override val itemType: Int = if(price_type == 1) 0 else 1
): MultiItemEntity

@JsonClass(generateAdapter = true)
data class PictureList(
    val list:List<PictureBean>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}