package com.at.video.atlas.entity

import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class PictureDetailBean(
    val id: String?,
    val name: String?,
    val categ_id: String?,
    val categ_name: String?,
    val subcateg_id: String?,
    val subcateg_name: String?,
    val publish_state: Int?,
    val price: String?,
    val price_type: String?,
    val author: String?,
    val introduction: String?,
    val cover_horizontal: String?,
    val cover_vertical: String?,
    val origin: String?,
    val chapter_count:String?,
    val picture_count:String?,
    val popularity:String?,
    val tags: String?,
    val keywords: String?,
    val site_id: String?,
    val created_at:String?,
    val updated_at:String?,
    var is_collect:Boolean = false,
    var is_star:Boolean = false
)

@JsonClass(generateAdapter = true)
data class WatchHistoryBean(
    val belong_app_id: String?,
    val cover: String?,
    val created_at: String?,
    val episode: String?,
    val id: String?,
    val name: String?,
    val percentage: String?,
    val price: String?,
    val price_type: String?,
    val progress: String?,
    val resource_id: String?,
    val type: Int?,
    val updated_at: String?,
    val user_id: String?
)

@JsonClass(generateAdapter = true)
data class PictureDetail(
    val picture:PictureDetailBean?,
    val picture_chapter_list:PictureChapterList?,
    val watch_history:WatchHistoryBean?,
    val status: PicStatus?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}
@JsonClass(generateAdapter = true)
data class PictureChapterList(
    val list:List<PictureChapter>?,
    val total:String?
)
@JsonClass(generateAdapter = true)
data class PictureChapter(
    val id:String?,
    val picture_id:String?,
    val name:String?,
    val number:String?,
    val url:String?,
    val created_at:String?,
    val updated_at:String?,
)

@JsonClass(generateAdapter = true)
data class PicStatus(
    val is_like:Int = 0,
    val is_collect:Int = 0,
    val is_watch:Int = 0
)