package com.at.video.atlas.http

import com.at.common.network.BaseBean
import com.at.video.atlas.entity.*
import retrofit2.http.*

/**
 * @Create_time: 2022/5/28 09:29
 * @Description:
 */

interface ApiService {

    // 购买图集
    @POST("orders/golds/{id}")
    suspend fun buyAtlas(@Path("id") id: Int, @Query("use") use: Int = 4): BaseBean<Any>

    // /////////////////新接口

    @GET("v1/cms/picture_recommend")
    suspend fun getHomePictureList(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): RecommendBean

    // 获取图集详情
    @GET("v1/cms/picture_details")
    suspend fun getPictureDetail(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): PictureDetail

    // 获取图集列表
    @GET("v1/cms/picture")
    suspend fun getPictureList(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): PictureList

    @GET("v1/cms/picture_filter")
    suspend fun getCondition(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): ConditionBean

    @GET("v1/cms/category_query")
    suspend fun getSubCondition(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): SubCategoryList
}
