package com.at.video.atlas.ui

import android.annotation.SuppressLint
import android.app.Activity
import android.app.Dialog
import android.view.LayoutInflater
import com.at.common.immersiveStatusBar
import com.at.common.setLightStatusBar
import com.at.video.atlas.R
import com.at.video.atlas.databinding.AtlasNoGoldDialogBinding
import com.at.video.atlas.databinding.AtlasPermissionDialogBinding

/**
 * @description:
 * @author:  stone
 * @email:
 * @date :   2022/6/8 下午3:23
 */
object AtlasDialog {

    interface AtlasListener {
        fun byGold()
        fun byMember()
    }

    @SuppressLint("SetTextI18n")
    fun createPermissionDialog(
        gold:Int,
        context: Activity,
        listener: AtlasListener? = null
    ): Dialog {
        val dialog = Dialog(context, R.style.atlas_dialog)
        val bind = AtlasPermissionDialogBinding.inflate(LayoutInflater.from(context))
        dialog.setContentView(bind.root)
        dialog.immersiveStatusBar()
        dialog.setLightStatusBar(true)
        dialog.setCanceledOnTouchOutside(false)
        bind.apply {
            stvBuyGold.text = "$gold 购买"
            stvBuyGold.setOnClickListener {
                listener?.byGold()
            }
            stvBuyMember.setOnClickListener {
                listener?.byMember()
            }
            ivCancel.setOnClickListener {
                dialog.dismiss()
                context.onBackPressed()
            }
        }
        dialog.setOnCancelListener {
            context.onBackPressed()
        }
        dialog.show()
        return dialog
    }

    interface BuyGoldListener{
        fun buyGold()
    }

    fun createNoGoldDialog(context: Activity, listener:BuyGoldListener?=null): Dialog {
        val dialog = Dialog(context, R.style.atlas_dialog)
        val bind = AtlasNoGoldDialogBinding.inflate(LayoutInflater.from(context))
        dialog.setContentView(bind.root)
        dialog.immersiveStatusBar()
        dialog.setLightStatusBar(true)
        bind.apply {
            tvLeft.setOnClickListener {
                dialog.dismiss()
            }
            tvRight.setOnClickListener {
                listener?.buyGold()
            }
        }
        dialog.show()
        return dialog
    }
}