package com.at.video.atlas.ui.atlas.binder

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.at.video.atlas.R
import com.at.video.atlas.entity.AtlasTypeInfo
import com.at.video.atlas.ui.atlas.AtlasDecoration
import com.chad.library.adapter.base.BaseBinderAdapter
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.router.api.launcher.Router
import com.melancholy.utils.AppInstance
import com.video.module_widget.utils.StyleUtils


/**
 * @Create_time: 2022/5/10 17:44
 * @Description:
 */

class AtlasListTypeBinder(val type: Int = 2, val spanCount:Int = 4) : BaseItemBinder<AtlasListTypeBinder.Data ,BaseViewHolder>(),OnItemClickListener{

    data class Data(val data: MutableList<Any>)


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder    =   BaseViewHolder(
    LayoutInflater.from(parent.context)
    .inflate(R.layout.atlas_list_type_data, parent, false)
    )
    override fun convert(holder: BaseViewHolder, data: Data) {
        val mAdapter: BaseBinderAdapter = BaseBinderAdapter()
        mAdapter.addItemBinder(AtlasTypeBinder(type))
        holder.getView<RecyclerView>(R.id.rv_data).apply {
            layoutManager =  GridLayoutManager(context, StyleUtils.getSpanCount(spanCount))
            addItemDecoration(AtlasDecoration())
            adapter = mAdapter
                        setPadding(0, AppInstance.getApplication().resources
                .getDimensionPixelSize(com.at.common.R.dimen.dp_16),0,0)
        }
        mAdapter.setNewInstance(data.data)
        mAdapter.setOnItemClickListener(this)
    }

    override fun onItemClick(adapter: BaseQuickAdapter<*, *>, view: View, position: Int) {
        val data = adapter.getItem(position) as AtlasTypeInfo
        Router.getInstance().build("/atlas/ClassifyActivity").withString("mCategoryId",if (data.id!="-1") data.id.toString() else "").navigation()

    }
}