package com.at.video.atlas.ui.detail.binder

import android.view.ViewGroup
import android.widget.ImageView
import com.at.common.ImageConfig
import com.at.common.load
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.video.module_widget.imageUrl


class ImageBinder: BaseItemBinder<String, BaseViewHolder>()  {

    override fun convert(holder: BaseViewHolder, data: String) {
        (holder.itemView as ImageView).load(
            ImageConfig(data.imageUrl(),
            placeholderId =  com.video.module_widget.R.drawable.common_ic_image_altas_default,
            errorId =  com.video.module_widget.R.drawable.common_ic_image_altas_default)
        )
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        val image = ImageView(parent.context)
        val params  = ViewGroup.LayoutParams(
            ViewGroup.LayoutParams.MATCH_PARENT,
            ViewGroup.LayoutParams.WRAP_CONTENT
        )
        image.layoutParams = params
        image.adjustViewBounds = true
        return BaseViewHolder(image)
    }
}