package com.at.video.atlas.widget

import com.at.video.atlas.widget.loader.ImageLoader
import android.graphics.drawable.Drawable
import androidx.annotation.StyleRes
import com.at.video.atlas.R
import android.content.pm.ActivityInfo

/**
 * @author
 */
enum class ViewerSpec {
    INSTANCE;

    @JvmField
    var position = 0
    @JvmField
    var listData: List<*>? = null
    @JvmField
    var imageLoader: ImageLoader? = null
    @JvmField
    var isShowIndicator = false
    @JvmField
    var placeholderDrawable: Drawable? = null
    @JvmField
    var errorDrawable: Drawable? = null

    @JvmField
    @StyleRes
    var theme = R.style.ImageViewerTheme
    @JvmField
    var orientation = ActivityInfo.SCREEN_ORIENTATION_BEHIND
    fun reset() {
        position = 0
        listData = null
        imageLoader = null
        isShowIndicator = false
        placeholderDrawable = null
        errorDrawable = null
        theme = R.style.ImageViewerTheme
        orientation = ActivityInfo.SCREEN_ORIENTATION_BEHIND
    }
}