package com.at.video.atlas.widget.loader;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.widget.ImageView;

import androidx.annotation.DrawableRes;
import androidx.annotation.Nullable;

import com.at.video.atlas.widget.ImageDataSource;

import java.io.File;


/**
 * 图片加载器，目前内置实现的加载器有{@link CoilLoader}。
 * 如果目前已有的加载器不满足您的需求，您也可以自己实现{@link ImageLoader}
 *
 * @author
 */
public interface ImageLoader {

    /**
     * 加载图片
     * @param context
     * @param imageView
     * @param data 图片数据源  支持 {@link Uri}, {@code url}, {@code path},{@link File}, {@link DrawableRes resId}, {@link ImageDataSource}...等
     * @param placeholderDrawable 占位图
     * @param errorDrawable  加载失败时显示的图片
     */
    void loadImage(Context context, ImageView imageView,Object data, @Nullable Drawable placeholderDrawable,@Nullable Drawable errorDrawable);
}
