package com.at.video.home.entity

import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class AreaList(
    val list:List<Area>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}


@JsonClass(generateAdapter = true)
data class SubCategoryList(
    val list:List<Category>?,
    val total:String?
)

@JsonClass(generateAdapter = true)
data class TypeBean(
    val id: String?,
    val name: String?,
    val module: Int?,
    val status: Int?,
    val order: String?,
    val site_id: String?,
    val categ_id: String?,
    val created_at: String?,
    val updated_at: String?
)

@JsonClass(generateAdapter = true)
data class TypeList(
    val list:List<TypeBean>?,
    val total:String?,
)

@JsonClass(generateAdapter = true)
data class Area(
    val id: String?,
    val name: String?,
    val order: String?,
    val site_id: String?,
    val created_at: String?,
    val updated_at: String?
)

@JsonClass(generateAdapter = true)
data class CategoryListBean(
    val list:List<TypeBean>?,
    val total:String?,
)

@JsonClass(generateAdapter = true)
data class Category(
    val id: String?,
    val module: Int?,
    val status: Int?,
    val position: Int?,
    val name: String?,
    val cover: String?,
    val order: String?,
    val parent_id: String?,
    val site_id: String?,
    val created_at: String?,
    val updated_at: String?
)

@JsonClass(generateAdapter = true)
data class YearList(
    val id: String?,
    val key:String?,
    val value:String?,
    val site_id:String?,
    val created_at: String?,
    val updated_at: String?
)
