package com.at.video.home.entity

import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.JsonClass

/**
 * @Create_time: 2022/5/26 17:58
 * @Description: 通知
 */

@JsonClass(generateAdapter = true)
data class NoticeInfo(
    val content: String,
    val createdAt: Int,
    val effectiveTime: Int,
    val enable: Int,
    val expirationTime: Long,
    val holdTime: Int = 0,
    val id: Int,
    val index: Int,
    val title: String,
    val type: Int,
    val updatedAt: Int
) : Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readString() ?: "",
        parcel.readInt(),
        parcel.readInt(),
        parcel.readInt(),
        parcel.readLong(),
        parcel.readInt(),
        parcel.readInt(),
        parcel.readInt(),
        parcel.readString() ?: "",
        parcel.readInt(),
        parcel.readInt()
    )

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(content)
        parcel.writeInt(createdAt)
        parcel.writeInt(effectiveTime)
        parcel.writeInt(enable)
        parcel.writeLong(expirationTime)
        parcel.writeInt(holdTime)
        parcel.writeInt(id)
        parcel.writeInt(index)
        parcel.writeString(title)
        parcel.writeInt(type)
        parcel.writeInt(updatedAt)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<NoticeInfo> {
        override fun createFromParcel(parcel: Parcel): NoticeInfo {
            return NoticeInfo(parcel)
        }

        override fun newArray(size: Int): Array<NoticeInfo?> {
            return arrayOfNulls(size)
        }
    }
}


@JsonClass(generateAdapter = true)
data class NoticeBean(
    val content: String?,
    val title: String?,
    val style:Int = 1,
    val created_at: String?
) : Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readString() ?: "",
        parcel.readString() ?: "",
        parcel.readInt(),
        parcel.readString() ?: ""

    )

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(content)
        parcel.writeString(title)
        parcel.writeInt(style)
        parcel.writeString(created_at)

    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<NoticeBean> {
        override fun createFromParcel(parcel: Parcel): NoticeBean {
            return NoticeBean(parcel)
        }

        override fun newArray(size: Int): Array<NoticeBean?> {
            return arrayOfNulls(size)
        }
    }
}

@JsonClass(generateAdapter = true)
data class NoticeList(
    val list:List<NoticeBean>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}
