package com.at.video.home.entity

import com.squareup.moshi.JsonClass
// 首页推荐实体类k
@JsonClass(generateAdapter = true)
data class RecommendBean(
    val code:Int = 200,
    val reason:String?,
    val message:String?,
    val latest_list:VideoList?,
    val hot_list:VideoList?,
    val category_list:List<CategoryVideoList>?,
    val album_list:List<AlbumVideoList>?
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}

@JsonClass(generateAdapter = true)
data class NavigationBean(
    val category_list:CategoryList?,
    val album_list: AlbumList?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}


@JsonClass(generateAdapter = true)
data class CategoryList(
    val list:List<CategoryBean>?,
    val total:String?
)
@JsonClass(generateAdapter = true)
data class AlbumList(
    val list:List<AlbumBean>?,
    val total:String?
)


@JsonClass(generateAdapter = true)
data class CategoryVideoList(
    val category: CategoryBean?,
    val list:VideoList?
)

@JsonClass(generateAdapter = true)
data class AlbumVideoList(
    val album: AlbumBean?,
    val list:VideoList?
)



@JsonClass(generateAdapter = true)
data class VideoList(
    val list:List<VideoBean>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}

@JsonClass(generateAdapter = true)
data class CategoryBean(
    val id: String?,
    val module:Int?,
    val name: String?,
    val cover:String?,
    val parent_id:String?,
    val site_id:String?,
    val created_at:String?,
    val updated_at:String?,
    val order: String?,
    val position:Int?,
    val status: Int?,
)

@JsonClass(generateAdapter = true)
data class AlbumBean(
    val id: String?,
    val module:Int?,
    val name: String?,
    val order: String?,
    val position: Int?,
    val price: String?,
    val price_type:Int?,
    val status: Int?,
    val site_id:String?,
    val created_at:String?,
    val updated_at:String?,
)
