package com.at.video.home.entity

import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class StarBean(
    val id: String?,
    val name: String?,
    val name_alias: String?,
    val name_eng: String?,
    val categ_id: String?,
    val categ_name: String?,
    val area_id: String?,
    val area_name: String?,
    val gender: Int?,
    val blood_type: String?,
    val constellation: String?,
    val height: String?,
    val weight: String?,
    val nationality: String?,
    val ethnic: String?,
    val birthday: String?,
    val birthplace: String?,
    val profession: String?,
    val brokerage: String?,
    val weibo: String?,
    val school: String?,
    val main_work: String?,
    val relation: String?,
    val introduction: String?,
    val cover_vertical: String?,
    val avatar: String?,
    val detail: String?,
    val created_at: String?,
    val updated_at: String?,
    val area: String?,
    val status: Int?,
    val site_id: String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}

@JsonClass(generateAdapter = true)
data class StarList(
    val list:List<StarBean>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}

@JsonClass(generateAdapter = true)
data class ActorCategory(
    val id:String?,
    val name:String?,
    val status:String?,
    val site_id:String?,
    val order:String?,
    val created_at:String?,
    val updated_at:String?
)

@JsonClass(generateAdapter = true)
data class ActorCategoryList(
    val list:List<ActorCategory>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?,
){
    fun msg():String = when(code){
        401->"未登录"
        else -> "成功"
    }

    fun success():Boolean = code ==200
}