package com.at.video.home.http

import com.at.common.network.BaseBean
import com.at.video.home.entity.*
import com.video.module_widget.entity.BaseResponse
import okhttp3.ResponseBody
import retrofit2.http.*

/**
 * @Create_time: 2022/5/24 10:08
 * @Description:
 */

interface ApiService {

    // 获取专辑顶部tab
    @GET("home/album")
    suspend fun getAlbumTab(@Query("resourceType") resourceType: Int = 1): BaseBean<List<TabInfo>>

    // 获取换一换数据
    @GET("home/change")
    suspend fun getChange(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): BaseBean<List<CategoryInfo>>

    // 搜索
    @GET("home/search")
    suspend fun search(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): BaseBean<Any>

    @GET("home/version/app/{id}")
    suspend fun getVersionInfo(@Path("id") appId: String): BaseBean<AppVersionInfo>

    // 下载文件
    @Streaming
    @GET
    suspend fun download(@Url url: String): ResponseBody

    // ///////////////////////////////////////////新版接口

    // 获取推荐的数据
    @GET("v1/cms/video_recommend")
    suspend fun recommend(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): RecommendBean

    // 获取推荐的数据
    @GET("v1/cms/video_navigation")
    suspend fun getTabs(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): NavigationBean

    // 获取视频列表
    @GET("v1/cms/video")
    suspend fun getFilmList(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): VideoList

    // 获取筛选条件
    @GET("v1/cms/video_filter")
    suspend fun getVideoConditions(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): ConditionBean

    // 获取演员列表
    @GET("v1/cms/actor")
    suspend fun getStarList(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): StarList

    // 获取演员分类
    @GET("v1/cms/actor_category_query")
    suspend fun getStarType(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): AreaList

    // 心跳
    @GET("v1/user/life_cycle")
    suspend fun heartbeat(@Query("source") source: String = "1", @Query("login_system_version") systemVersion: String = "", @Query("login_device_name") deviceName: String = ""): BaseResponse

    // 公告
    @GET("v1/announcement")
    suspend fun getNotice(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): NoticeList
}
