package com.at.video.home.ui.classify

import android.graphics.Color
import android.graphics.Typeface
import android.util.Log
import android.view.View
import com.at.video.home.R
import com.at.video.home.entity.ConditionsInfo
import com.at.video.home.ui.classify.binder.ConditionsBinder
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.video.module_widget.entity.Content
import com.video.module_widget.utils.toArgb
import com.video.module_widget.widget.ShapeTextViewExt

/**
 * @Create_time: 2022/5/10 20:29
 * @Description: 筛选条件
 */

class ClassifyTypeAdapter(val style:Content?): BaseQuickAdapter<ConditionsInfo,
        BaseViewHolder>(R.layout.home_item_classify_type) {
    private lateinit var mConditions: ConditionsBinder.Conditions

    private var mSelectIndex: Int = 0

    override fun convert(holder: BaseViewHolder, item: ConditionsInfo) {
        holder.setText(R.id.stv_filter, item.name)
//            .setEnabled(R.id.stv_filter, mSelectIndex != holder.bindingAdapterPosition)
        changeTabStyle(mSelectIndex == holder.bindingAdapterPosition,holder.getView(R.id.stv_filter))
    }

    override fun convert(holder: BaseViewHolder, item: ConditionsInfo, payloads: List<Any>) {
        changeTabStyle(mSelectIndex != holder.bindingAdapterPosition,holder.getView(R.id.stv_filter))
//        holder.setEnabled(R.id.stv_filter, mSelectIndex != holder.bindingAdapterPosition)
    }

    private fun changeTabStyle(isSelected:Boolean, shapeTextViewExt: ShapeTextViewExt){
        style?.config?.let {
            var txtColor = -1
            it.text?.apply {
                txtColor = if(isSelected) selectedColor!!.toArgb() else color!!.toArgb()
            }
            val bgColor = if(isSelected) it.fill!!.toArgb() else Color.WHITE

            var borderWidth = 0
            var borderColor = ""
            var borderRadius = 0
            it.border?.apply {
               borderWidth = if(isSelected) width else 0
               borderColor = color!!
               borderRadius = radius
            }

            shapeTextViewExt.apply {
                typeface = if(isSelected) Typeface.DEFAULT_BOLD else Typeface.DEFAULT
                setTextColor(txtColor)
                setBackgroundColorWithRGBA(bgColor)
                setBorderWidth(borderWidth)
                setBorderRadius(borderRadius)
                setBorderColor(borderColor)
                reBuilder()
            }
        }
    }

    override fun setOnItemClick(v: View, position: Int) {
        super.setOnItemClick(v, position)
        Log.d("TAG123456987", "${getConditions()}")
    }

    fun setConditions(conditions: ConditionsBinder.Conditions) {
        mConditions = conditions
        setNewInstance(conditions.list.toMutableList())
        setSelectIndex(conditions.index)
    }

    private fun setSelectIndex(index: Int) {
        val prevIndex: Int = mSelectIndex
        mSelectIndex = index
        notifyItemChanged(mSelectIndex,"notify")
        notifyItemChanged(prevIndex, "notify")
    }

    fun getConditions(): ConditionsBinder.Conditions = mConditions
}