package com.at.video.home.ui.home.binder

import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import android.widget.ImageView
import com.at.video.home.R
import com.at.video.home.entity.VideoBean
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.widget.DiversityImageView
import com.video.module_widget.imageUrl
import com.video.module_widget.utils.GlideImageConfig
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.utils.loadByGlide
import com.video.module_widget.widget.ShapeTextViewExt
import java.lang.ref.WeakReference

/**
 * @Create_time: 2022/5/24 20:46
 * @Description: 免费
 */

class CommonFreeBinder(val type:Int = 1): BaseItemBinder<CommonFreeBinder.Free, BaseViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        return BaseViewHolder(LayoutInflater.from(parent.context)
            .inflate(R.layout.home_common_free_view, parent, false))
    }

    private fun getRootParamsByStyleType():FrameLayout.LayoutParams{
        val params = FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT, StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_137))

        when(type) {
            2 -> {
               params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_200)
            }
            3 -> {
                params.width = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_136)
                params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_220)
            }
        }
        return params
    }


    private fun getImageParamsByType() = when(type){
        2->{
            com.at.common.R.dimen.dp_150
        }
        3->{
            com.at.common.R.dimen.dp_170
        }
        else ->{
            com.at.common.R.dimen.dp_92
        }
    }
    private fun changeTagStyle(tagView: ShapeTextViewExt){
        val params = tagView.layoutParams as FrameLayout.LayoutParams
        when(StyleUtils.tagStyle){
            2->{
                tagView.setBorderRadius(com.at.common.R.dimen.dp_10)
                params.rightMargin = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_4)
                params.topMargin = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_4)
                tagView.reBuilder()
            }
            3->{
                tagView.setBorderRadius(com.at.common.R.dimen.dp_10,com.at.common.R.dimen.dp_10)
                params.topMargin = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_8)
                tagView.reBuilder()
            }
        }
    }


    override fun convert(holder: BaseViewHolder, data: Free) {
        val root = holder.getView<FrameLayout>(R.id.ll_recommend1)
        root.layoutParams = getRootParamsByStyleType()
        val image = holder.getView<DiversityImageView>(R.id.div_image)
        val params = image.layoutParams
        params.height = StyleUtils.getDpByDimen(getImageParamsByType())
        if(StyleUtils.tagEnable){
            changeTagStyle(holder.getView<ShapeTextViewExt>(R.id.stv_tag))
        }else{
            holder.getView<ShapeTextViewExt>(R.id.stv_tag).visibility = View.GONE
        }

        val orientation = if(type == 1) 0 else 1
        var imageUrl = ""
        imageUrl = if(orientation == 0) {
            if(data.data.cover_horizontal?.isNotEmpty() == true)  data.data.cover_horizontal else data.data.cover_vertical.toString()
        }else {
            if(data.data.cover_vertical?.isNotEmpty() == true)  data.data.cover_vertical else data.data.cover_horizontal.toString()
        }
        image.layoutParams = params
        holder.getView<ImageView>(R.id.div_image)
            .loadByGlide(
                GlideImageConfig(imageUrl.imageUrl(),
                placeholderId =  com.video.module_widget.R.drawable.common_ic_image_video_default,
                errorId =  com.video.module_widget.R.drawable.common_ic_image_video_default),
                WeakReference(context)
            )
        holder.setText(R.id.tv_play_count, data.data.popularity)
            .setText(R.id.tv_remarks,data.data.note)
            .setText(R.id.tv_title, data.data.name)
            .setText(R.id.tv_time, "${data.data.highlight}")
//            .setText(R.id.tv_time, "${data.data.release_date}000".formatTimeMills()?.parseString())
    }

    data class Free(val data: VideoBean)
}