package com.at.video.home.ui.home.binder

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.at.common.global.Constants
import com.at.video.home.R
import com.at.video.home.databinding.HomeFunctionViewBinding
import com.video.module_widget.entity.AdvertisingInfo
import com.chad.library.adapter.base.binder.QuickViewBindingItemBinder
import com.melancholy.router.api.launcher.Router

/**
 * @Create_time: 2022/4/27 19:14
 * @Description: 功能模块
 */

class FunctionBinder: QuickViewBindingItemBinder<FunctionBinder.FunctionInfo,
        HomeFunctionViewBinding>(), View.OnClickListener {

    override fun onCreateViewBinding(layoutInflater: LayoutInflater, parent: ViewGroup,
                                     viewType: Int): HomeFunctionViewBinding {
        val binding = HomeFunctionViewBinding.inflate(layoutInflater, parent, false)
        binding.llNovel.setOnClickListener(this)
        binding.llAtlas.setOnClickListener(this)
        binding.llAd1.setOnClickListener(this)
        binding.llAd2.setOnClickListener(this)
        return binding
    }

    override fun convert(holder: BinderVBHolder<HomeFunctionViewBinding>, data: FunctionInfo) {
//        data.list?.apply {
//            if(size > 0) {
//                holder.viewBinding.llAd1.visibility = View.VISIBLE
//                holder.viewBinding.llAd1.tag = get(0)
//                holder.viewBinding.divAd1.load(ImageConfig(get(0).addr.imageUrl(),
//                    placeholderId = R.drawable.home_ic_ad_function_default,
//                    errorId = R.drawable.home_ic_ad_function_default))
//                holder.viewBinding.tvAd1.text ="精彩广告"
//            }
//            if(size > 1) {
//                holder.viewBinding.llAd2.visibility = View.VISIBLE
//                holder.viewBinding.llAd2.tag = get(1)
//                holder.viewBinding.divAd2.load(ImageConfig(get(1).addr.imageUrl(),
//                    placeholderId = R.drawable.home_ic_ad_function_default,
//                    errorId = R.drawable.home_ic_ad_function_default))
//                holder.viewBinding.tvAd2.text = "精彩广告"
//            }
//        }
    }

    override fun onClick(view: View) {
        when(view.id) {
            R.id.ll_novel -> {
                Router.getInstance().build("/novel/NovelActivity").navigation()
            }
            R.id.ll_atlas -> {
                Router.getInstance().build("/atlas/AtlasActivity").navigation()
            }
            R.id.ll_ad_1->{
                val data: AdvertisingInfo = view.tag as AdvertisingInfo
                Router.getInstance().build("/webview/WebViewActivity")
                    .withString(Constants.KEY_DATA, data.jumpAddr)
                    .navigation()
            }
            R.id.ll_ad_2->{
                val data: AdvertisingInfo = view.tag as AdvertisingInfo
                Router.getInstance().build("/webview/WebViewActivity")
                    .withString(Constants.KEY_DATA, data.jumpAddr)
                    .navigation()
            }
        }
    }

    data class FunctionInfo(val list: List<AdvertisingInfo>?)
}