package com.at.video.home.ui.home.binder

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.at.common.global.Constants
import com.at.video.home.R
import com.at.video.home.ui.home.IntervalDecoration
import com.chad.library.adapter.base.BaseBinderAdapter
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.google.android.material.button.MaterialButton
import com.google.android.material.button.MaterialButton.ICON_GRAVITY_TEXT_END
import com.google.android.material.button.MaterialButton.ICON_GRAVITY_TEXT_START
import com.melancholy.router.api.launcher.Router
import com.video.module_widget.utils.StyleUtils

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/8/29 上午10:27
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/8/29 上午10:27
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
class VideoListBinder(): BaseItemBinder<VideoListBinder.Data,BaseViewHolder>(),
    OnItemClickListener {

    data class Data(val data:MutableList<Any>,val type:Int = 1,val isMore:Boolean)
//
//    init {
//        mAdapter.addItemBinder(CommonFreeBinder())
//        mAdapter.addItemBinder(CommonPayBinder())
//    }
   private val intervalDecoration = IntervalDecoration()
    private val horizontalIntervalDecoration =HorizontalIntervalDecoration()
    override fun convert(holder: BaseViewHolder, data: Data) {
        val mAdapter: BaseBinderAdapter = BaseBinderAdapter()
        if(data.isMore){
            mAdapter.addItemBinder(CommonSingleBinder())
        }
        if(!data.isMore || data.type == 1){
            mAdapter.addItemBinder(CommonFreeBinder(data.type))
            mAdapter.addItemBinder(CommonPayBinder(data.type))
        }


        holder.getView<RecyclerView>(R.id.rv_data).apply {
           adapter = mAdapter
            when(data.type){
                1->{
                   layoutManager = GridLayoutManager(context, 2)
                   removeItemDecoration(intervalDecoration)
                   addItemDecoration(intervalDecoration)
                }
                2->{
                    if(data.isMore){
                        layoutManager = LinearLayoutManager(context,RecyclerView.HORIZONTAL,false)
                        removeItemDecoration(horizontalIntervalDecoration)
                        addItemDecoration(horizontalIntervalDecoration)
                    }else{
                        layoutManager = GridLayoutManager(context, 3)
                        removeItemDecoration(intervalDecoration)
                        addItemDecoration(intervalDecoration)
                    }
                }
                3->{
                    layoutManager = LinearLayoutManager(context,RecyclerView.HORIZONTAL,false)
                    removeItemDecoration(horizontalIntervalDecoration)
                    addItemDecoration(horizontalIntervalDecoration)
                }
            }
      }
        mAdapter.setNewInstance(data.data)
        mAdapter.setOnItemClickListener(this)

    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder  = BaseViewHolder(
        LayoutInflater.from(parent.context)
         .inflate(R.layout.home_video_list_binder, parent, false))

    override fun onItemClick(adapter: BaseQuickAdapter<*, *>, view: View, position: Int) {
        val data = adapter.getItem(position)
        if(data is CommonFreeBinder.Free) {
            Router.getInstance().build("/player/PlayerActivity")
                .withString(Constants.KEY_DATA, data.data.id!!).navigation()
        } else if(data is CommonPayBinder.Pay) {
            Router.getInstance().build("/player/PlayerActivity")
                .withString(Constants.KEY_DATA, data.data.id!!).navigation()
        }
    }
}


