package com.at.video.home.ui.home.star

import android.content.Context
import android.util.AttributeSet
import android.util.Log
import android.view.MotionEvent
import android.view.ViewConfiguration
import androidx.recyclerview.widget.RecyclerView
import androidx.viewpager2.widget.ViewPager2
import kotlin.math.abs

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/7/26 下午3:56
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/7/26 下午3:56
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
class CustomRecyclerview(context: Context,attrs:AttributeSet):RecyclerView(context,attrs) {

    private var downX: Float = 0f
    private var downY: Float = 0f
    private var isDragged = false
    private val touchSlop = ViewConfiguration.get(context).scaledTouchSlop
    override fun onInterceptTouchEvent(ev: MotionEvent): Boolean {
        val parentView = parent.parent.parent.parent.parent.parent as? ViewPager2
        when (ev.action) {
            MotionEvent.ACTION_DOWN -> {
                downX = ev.x
                downY = ev.y
                isDragged = false
                parentView?.let {
                    requestDisallowInterceptTouchEvent(true)
                }
            }
            MotionEvent.ACTION_MOVE -> {
                if (!isDragged) {
                    val dx = abs(ev.x - downX)
                    val dy = abs(ev.y - downY)
                    isDragged =  dx - dy >0
                    Log.e("vertical","dx:${dx},dy:${dy},isDragged:${isDragged}")
//                        parent.requestDisallowInterceptTouchEvent(false)
                    parentView?.let {
                        it.isUserInputEnabled = !isDragged
                        requestDisallowInterceptTouchEvent(isDragged)
                    }
                }
            }
            MotionEvent.ACTION_UP, MotionEvent.ACTION_CANCEL -> {
                isDragged = false
                parentView?.let {
                    it.isUserInputEnabled = false
                    requestDisallowInterceptTouchEvent(false)
                }
            }
        }
        return super.onInterceptTouchEvent(ev)
    }
}