package com.at.video.home.ui.home.star.binder

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import android.widget.ImageView
import com.at.video.home.R
import com.at.video.home.entity.StarBean
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.widget.DiversityImageView
import com.video.module_widget.imageUrl
import com.video.module_widget.utils.GlideImageConfig
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.utils.loadByGlide
import com.video.module_widget.utils.toArgb
import java.lang.ref.WeakReference

/**
 * @Create_time: 2022/4/27 21:04
 * @Description:
 */

class StarBinder: BaseItemBinder<StarBinder.Data, BaseViewHolder>(){

    data class Data(val data:StarBean,var type:Int = 1,var titleColor:String)
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {

        val binding = LayoutInflater.from(parent.context)
            .inflate(R.layout.home_star_view, parent, false)
        return BaseViewHolder(binding)
    }

    override fun convert(holder: BaseViewHolder, data: Data) {
        val root = holder.getView<FrameLayout>(R.id.fl_root)
        root.layoutParams = getRootParamsByStyleType(data.type)
        val image = holder.getView<DiversityImageView>(R.id.div_image)
        val params = image.layoutParams
        params.height = StyleUtils.getDpByDimen(getImageParamsByType(data.type))
        holder.getView<ImageView>(R.id.div_image)
            .loadByGlide(
                GlideImageConfig(data.data.cover_vertical.imageUrl(),
                    placeholderId = com.video.module_widget.R.drawable.common_ic_image_altas_default,
                    errorId = com.video.module_widget.R.drawable.common_ic_image_altas_default),
                WeakReference(context)
            )
        holder.setText(R.id.stv_name, data.data.name)
        holder.setTextColor(R.id.stv_name,data.titleColor.toArgb())
    }


    private fun getRootParamsByStyleType(type:Int): FrameLayout.LayoutParams{
        val params = FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT, StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_137))

        when(type) {
            1-> {
                params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_178)
            }
            2 -> {
                params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_120)
            }
        }
        return params
    }


    private fun getImageParamsByType(type:Int) = when(type){
        1->{
            com.at.common.R.dimen.dp_141
        }
        2->{
            com.at.common.R.dimen.dp_100
        }
        else ->{
            com.at.common.R.dimen.dp_141
        }
    }
}