package com.at.video.home.ui.home.star.binder

import android.widget.FrameLayout
import android.widget.ImageView
import com.at.video.home.R
import com.at.video.home.entity.StarBean
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.widget.DiversityImageView
import com.video.module_widget.imageUrl
import com.video.module_widget.utils.GlideImageConfig
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.utils.loadByGlide
import com.video.module_widget.utils.toArgb
import java.lang.ref.WeakReference

/**
 * @Create_time: 2022/5/13 13:47
 * @Description:
 */

class StartAdapter: BaseQuickAdapter<StarBean, BaseViewHolder>(R.layout.home_star_view) {
    override fun convert(holder: BaseViewHolder, data: StarBean) {
        val root = holder.getView<FrameLayout>(R.id.fl_root)
        root.layoutParams = getRootParamsByStyleType()
        val image = holder.getView<DiversityImageView>(R.id.div_image)
        val params = image.layoutParams
        params.height = StyleUtils.getDpByDimen(getImageParamsByType())
        holder.getView<ImageView>(R.id.div_image)
            .loadByGlide(
                GlideImageConfig(data.cover_vertical.imageUrl(),
                placeholderId = com.video.module_widget.R.drawable.common_ic_image_altas_default,
                errorId = com.video.module_widget.R.drawable.common_ic_image_altas_default),
                WeakReference(context)
            )
        holder.setText(R.id.stv_name, data.name)
        holder.setTextColor(R.id.stv_name,titleColor.toArgb())
    }

    private var type:Int = 1
    fun setType(mType:Int){
        type = mType
    }

    private var titleColor = "rgba(0,0,0,1)"

    fun setTitleColor(color:String?){
        color?.let {
            titleColor = color
        }
    }

    private fun getRootParamsByStyleType(): FrameLayout.LayoutParams{
        val params = FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT, StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_137))

        when(type) {
            1-> {
                params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_178)
            }
            2 -> {
                params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_120)
            }
        }
        return params
    }


    private fun getImageParamsByType() = when(type){
        1->{
            com.at.common.R.dimen.dp_141
        }
        2->{
            com.at.common.R.dimen.dp_100
        }
        else ->{
            com.at.common.R.dimen.dp_141
        }
    }
}