package com.at.video.home.ui.home.star.binder

import com.at.video.home.R
import com.at.video.home.entity.Area
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.utils.DensityUtils
import com.video.module_widget.entity.Content
import com.video.module_widget.utils.getSp
import com.video.module_widget.utils.toArgb
import com.video.module_widget.widget.ShapeTextViewExt

/**
 * @Create_time: 2022/5/13 13:47
 * @Description:
 */

class StartTypeAdapter(private val contentStyle:Content? = null): BaseQuickAdapter<Area, BaseViewHolder>(R.layout.home_item_start_type) {

    private var mSelectIndex: Int = 0

    override fun convert(holder: BaseViewHolder, item: Area) {
        holder.setText(R.id.tv_text, item.name)
        val tvTxt = holder.getView<ShapeTextViewExt>(R.id.tv_text)
        setButtonStyle(mSelectIndex == holder.bindingAdapterPosition,tvTxt)
//        tvTxt.setTextColor(if(mSelectIndex == holder.bindingAdapterPosition)context.resources.getColor(R.color.color_FFFFFFFF)else context.resources.getColor(R.color.color_FF48494D))
//        tvTxt.setBackgroundResource(if(mSelectIndex == holder.bindingAdapterPosition) R.drawable.home_start_type_check_bg else R.drawable.home_start_type_bg)
    }
    override fun convert(holder: BaseViewHolder, item: Area, payloads: List<Any>) {
        val tvTxt = holder.getView<ShapeTextViewExt>(R.id.tv_text)
        setButtonStyle(mSelectIndex == holder.bindingAdapterPosition,tvTxt)
//        tvTxt.setTextColor(if(mSelectIndex == holder.bindingAdapterPosition)context.resources.getColor(R.color.color_FFFFFFFF)else context.resources.getColor(R.color.color_FF48494D))
//        tvTxt.setBackgroundResource(if(mSelectIndex == holder.bindingAdapterPosition) R.drawable.home_start_type_check_bg else R.drawable.home_start_type_bg)
    }

    private fun setButtonStyle(isSelected:Boolean,shapeTextViewExt: ShapeTextViewExt){
        contentStyle?.let { content ->
            content.config?.let {
                val textColor = if(isSelected) it.text!!.selectedColor else it.text!!.color
                val textBg = if(isSelected) it.tag!!.selected else it.tag!!.color
                val border = if(isSelected) it.border!!.selected else it.border!!.color
                val textSize = if(isSelected) it.text!!.selectedSize else it.text!!.size
                shapeTextViewExt.apply {
                    setTextColor(textColor!!.toArgb())
                    setBackgroundColor(textBg!!)
                    setBorderRadius(it.border!!.radius)
                    setBorderWidth(it.border!!.width)
                    setBorderColor(border!!)
                    setTextSize(DensityUtils.px2sp(context, context.getSp(textSize).toInt()))
                    reBuilder()
                }
            }

        }
    }

    fun setSelectIndex(index: Int) {
        val prevIndex: Int = mSelectIndex
        mSelectIndex = index
        notifyItemChanged(mSelectIndex,"notify")
        notifyItemChanged(prevIndex, "notify")
    }
}