package com.at.video.home.ui.search

import android.graphics.Color
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.style.ForegroundColorSpan
import java.util.regex.Matcher
import java.util.regex.Pattern

/**
 *  关键字高亮显示
 *  text  原文
 *  keyWord 需要高亮显示的关键字
 *  color 高亮展示颜色
 **/
fun String.stringToHighLight(keyWord: String, color: String = "#FF512C"): SpannableStringBuilder {
    val spannable = SpannableStringBuilder(this)
    try {
        val keyword: MutableList<String> = arrayListOf(keyWord)
        var wordReg: String
        for (i in keyword.indices) {
            var key = ""
            if (keyword[i].contains("*") || keyword[i].contains("(") || keyword[i].contains(")")) {
                val chars = keyword[i].toCharArray()
                for (k in chars.indices) {
                    key = if (chars[k] == '*' || chars[k] == '(' || chars[k] == ')') {
                        key + "\\" + chars[k].toString()
                    } else {
                        key + chars[k].toString()
                    }
                }
                keyword[i] = key
            }
            wordReg = "(?i)" + keyword[i]
            val pattern: Pattern = Pattern.compile(wordReg)
            val matcher: Matcher = pattern.matcher(this)
            while (matcher.find()) {
                spannable.setSpan(ForegroundColorSpan(Color.parseColor(color)), matcher.start(), matcher.end(), Spannable.SPAN_MARK_MARK)
                break//只执行一次
            }
        }
    } catch (e: Exception) {
    }
    return spannable
}
