package com.at.video.home.ui.search

import android.app.Application
import com.at.common.mvi.BaseAndroidViewModel
import com.at.common.mvi.IUiEffect
import com.at.common.mvi.IUiEvent
import com.at.common.mvi.IUiState
import com.at.common.status.PageStatus
import com.at.video.home.entity.CategoryInfo
import dagger.hilt.android.lifecycle.HiltViewModel
import javax.inject.Inject

/**
 * @Create_time: 2022/4/28 19:11
 * @Description:
 */

data class SearchUiState(
    val data: String = "ViewModel中的数据",
    val keyword:String? = null,
    val history:String?=null
): IUiState

sealed class SearchUiEvent: IUiEvent {
    data class SearchDataKey(val keyword: String?): SearchUiEvent()
    data class AddHistory(val keyword: String?):SearchUiEvent()
}

sealed class SearchUiEffect: IUiEffect {

}

class SearchViewModel(application: Application):
    BaseAndroidViewModel<SearchUiState, SearchUiEvent, SearchUiEffect>(application) {

    override fun providerInitialState(): SearchUiState {
        return SearchUiState()
    }

    override fun handleEvent(event: SearchUiEvent) {
        when(event){
            is SearchUiEvent.SearchDataKey -> {
                setState { copy(keyword = event.keyword) }
            }
            is SearchUiEvent.AddHistory-> setState { copy(history =event.keyword) }
        }
    }
}