package com.at.video.home.ui.search.mapping

import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.DividerItemDecoration
import androidx.recyclerview.widget.LinearLayoutManager
import com.at.common.databinding.CommonStatusRefreshListBinding
import com.at.common.mvi.BaseMviFragment
import com.at.video.home.R
import com.at.video.home.ui.search.DividerLineDecoration
import com.melancholy.router.annotation.annotation.Route
import dagger.hilt.android.AndroidEntryPoint

/**
 * @Create_time: 2022/4/28 19:23
 * @Description:
 */

@AndroidEntryPoint
@Route(path = "/home/SearchMappingFragment")
class SearchMappingFragment: BaseMviFragment<CommonStatusRefreshListBinding,
        SearchMappingViewModel>() {
    private val mAdapter: SearchMappingAdapter = SearchMappingAdapter()

    override fun createViewBinding(inflater: LayoutInflater, container: ViewGroup?,
                                   savedInstanceState: Bundle?): CommonStatusRefreshListBinding {
        return CommonStatusRefreshListBinding.inflate(inflater, container, false)
    }

    override fun getViewModelClass(): Class<SearchMappingViewModel> {
        return SearchMappingViewModel::class.java
    }

    override fun initialize(view: View, savedInstanceState: Bundle?) {
        requireBinding().includedRefreshList.apply {
            rvList.layoutManager = LinearLayoutManager(requireContext())
            rvList.adapter = mAdapter
            val divider = DividerLineDecoration()
            divider.setDrawable(ColorDrawable(resources.getColor(R.color.color_FFF1F3F7)))
            divider.setPaddingHorizontal(view.context.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_16))
            divider.setLineHeight(view.context.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_1))
            rvList.addItemDecoration(divider)
        }
        for (i: Int in 0 until 10) {
            mAdapter.addData("我们的故事$i")
        }

    }

    override fun loadData() {

    }
}