package com.at.video.home.ui.search.result

import android.view.ViewGroup
import com.at.video.home.R
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder

/**
 * @Create_time: 2022/5/11 20:49
 * @Description:
 */

class TeleplayLevelAdapter: BaseQuickAdapter<String, BaseViewHolder>(R.layout.home_item_teleplay_level) {


    override fun createBaseViewHolder(parent: ViewGroup, layoutResId: Int): BaseViewHolder {
        val holder: BaseViewHolder = super.createBaseViewHolder(parent, layoutResId)
        val params: ViewGroup.LayoutParams = holder.itemView.layoutParams
        val padding: Int = parent.context.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_40)
        params.width = (parent.width - padding) / 6
        holder.itemView.layoutParams = params
        return holder
    }

    override fun getDefItemCount(): Int {
        return if(isMoreThan()) 6 else data.size
    }

    private fun isMoreThan(): Boolean = data.size > 6

    override fun convert(holder: BaseViewHolder, item: String) {
        val position: Int = holder.bindingAdapterPosition
        if(position >= 2 && isMoreThan()) {
            if(position == 2) {
                holder.setText(R.id.stv_level, "...")
            } else {
                holder.setText(R.id.stv_level, getItem(data.size - (6 - position)))
            }
        } else {
            holder.setText(R.id.stv_level, item)
        }
    }
}