package com.at.video.main.entity

import com.squareup.moshi.JsonClass

/**
 * @Create_time: 2022/6/18 12:52
 * @Description: 协议相关信息
 */

@JsonClass(generateAdapter = true)
data class AgreementInfo(
    //隐私协议ID
    val id: Int,
    //用户协议
    val userAgreement: String,
    //隐私政策
    val privacyPolicy: String,
    //更新时间
    val updatedAt: Int,
    //创建时间
    val createdAt: Int
)

@JsonClass(generateAdapter = true)
data class Agreement(
    val agreement_type: Int,
    val content: String
)

@JsonClass(generateAdapter = true)
data class AgreementBean(
    val agreements: List<Agreement>?,
    val code: Int = 200,
    val reason: String?,
    val message: String?
) {
    fun msg(): String = when (code) {
        401 -> "未登录"
        else -> message ?: ""
    }

    fun success(): Boolean = code == 200
}

@JsonClass(generateAdapter = true)
data class TrackerBean(
    val trackers: List<String>?,
    val code: Int = 200,
    val reason: String?,
    val message: String?
) {
    fun success(): Boolean = code == 200
}