package com.at.video.main.entity

import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class AppInfo(
    val application: Application?,
    val application_version: ApplicationVersion?,
    val code: Int = 200,
    val reason: String?,
    val message: String?
) {
    fun msg(): String = when (code) {
        401 -> "未登录"
        else -> message ?: ""
    }

    fun success(): Boolean = code == 200
}

data class AppResInfo(
    val userAgreement: String = "",
    val privacyPolicy: String = "",
    val applicationCode: Int = 0,
    val appUpdateContent: String = "",
    val appDownloadUrl: String = "",
    val advLibId: String = "",
    val videoLibId: String = "",
    val imageLibId: String = "",
    val articleLibId: String = "",
    val isConfigEmail: Boolean = false,
    val minio_pkg_address: String = "",
    val appName: String = "",
    val upgrade: Int = 1,
    val versionName: String = ""
)

@JsonClass(generateAdapter = true)
data class Application(
    val advert_id: String?,
    val application_id: String?,
    val application_status: Int?,
    val apply_time: String?,
    val cms_address: String?,
    val content: Content?,
    val content_status: Int?,
    val created_at: String?,
    val logo: String?,
    val name: String?,
    val template_id: String?,
    val updated_at: String?,
    val webmaster_id: String?,
    val webmaster_name: String?,
    /**
     * 分享地址
     */
    val share_address: String?
)

@JsonClass(generateAdapter = true)
data class ApplicationVersion(
    val android: Android?
)

@JsonClass(generateAdapter = true)
data class Android(
    val latest_version_name: String?,
    val minio_pkg_address: String?,
    val pkg_address: String?,
    val rollback_code: Int?,
    val upgrade: Int?,
    val version_code: Int?,
    val version_content: String?,
    val version_id: String?,
    val version_name: String?
)

@JsonClass(generateAdapter = true)
data class Content(
    val article: String?,
    val image: String?,
    val video: String?
)