package com.at.video.main.http

import com.at.common.network.BaseBean
import com.at.video.main.entity.*
import okhttp3.ResponseBody
import retrofit2.Call
import retrofit2.http.*

/**
 * @Create_time: 2022/5/30 19:01
 * @Description:
 */
interface ApiService {

    // 获取配置信息
    @GET("configurations/settings")
    suspend fun getSettings(): BaseBean<SettingsInfo>

    // 获取协议
    @GET("configurations/agreements")
    suspend fun getAgreements(): BaseBean<AgreementInfo>

    @GET("v1/cms/template")
    suspend fun getTemplate(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): TemplateBean

    // 下载文件
    @Streaming
    @GET
    suspend fun download(@Url url: String): ResponseBody

    @GET
    fun ping(@Url url: String): Call<BaseBean<Any>>

    // 获取应用信息
    @GET("v1/user/application")
    suspend fun getAppInfo(): AppInfo

    // 获取用户协议
    @GET("v1/agreement")
    suspend fun getAgreement(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): AgreementBean

    @POST
    suspend fun getDomains(
        @Url url: String,
        @Body map: @JvmSuppressWildcards Map<String, Any>
    ): Domains

    // 是否存在邮箱配置
    @POST("v1/email_config/existed")
    suspend fun isEmailConfig(@Body map: @JvmSuppressWildcards Map<String, Any>): EmailConfig

    /**
     * 获取磁力链接，tracker 信息
     */
    @GET("v1/tracker/list")
    suspend fun getTrackerList(): TrackerBean
}
