package com.at.video.main.ui.splash

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.FragmentManager
import com.at.common.binding.BaseBindingDialogFragment
import com.at.video.main.R
import com.at.video.main.databinding.SplashDialogBinding

/**
 * @Create_time: 2022/6/22 16:25
 * @Description:
 */

class HintDialog : BaseBindingDialogFragment<SplashDialogBinding>(), View.OnClickListener {

    private var mCallback: ((Boolean) -> Unit)? = null

    companion object {
        @JvmStatic
        fun showDialog(manager: FragmentManager, callback: ((Boolean) -> Unit)) {
            val dialog = HintDialog()
            dialog.setCallback(callback)
            dialog.show(manager, null)
        }
    }

    fun setCallback(callback: ((Boolean) -> Unit)) {
        mCallback = callback
    }

    override fun getCancelable(): Boolean = false

    override fun getCustomTheme(): Int = R.style.HintDialog

    override fun getWidth(): Int = resources.getDimensionPixelSize(com.at.common.R.dimen.dp_300)

    override fun createViewBinding(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): SplashDialogBinding {
        return SplashDialogBinding.inflate(layoutInflater, container, false)
    }

    override fun initialize(view: View, savedInstanceState: Bundle?) {
        requireBinding().apply {
            tvLeft.setOnClickListener(this@HintDialog)
            tvRight.setOnClickListener(this@HintDialog)
        }
    }

    override fun loadData() {
    }

    override fun onClick(v: View) {
        if (v.id == R.id.tv_left) {
            mCallback?.invoke(true)
        } else {
            mCallback?.invoke(false)
        }
        dismiss()
    }
}
