package com.at.video.member.ui

import android.app.Activity
import android.app.Dialog
import android.view.LayoutInflater
import com.at.common.immersiveStatusBar
import com.at.common.setLightStatusBar
import com.at.video.member.R
import com.at.video.member.databinding.MemberNoGoldDialogBinding
import com.at.video.member.databinding.MemberPermissionDialogBinding

/**
 * @description:
 * @author:  stone
 * @email:
 * @date :   2022/6/8 下午3:23
 */
object MemberDialog {

    interface AtlasListener {
        fun byGold()
        fun byMember()
    }

    fun createPermissionDialog(
        context: Activity,
        listener: AtlasListener? = null
    ): Dialog {
        val dialog = Dialog(context, R.style.member_dialog)
        val bind = MemberPermissionDialogBinding.inflate(LayoutInflater.from(context))
        dialog.setContentView(bind.root)
        dialog.immersiveStatusBar()
        dialog.setLightStatusBar(true)
        dialog.setCanceledOnTouchOutside(false)

        bind.apply {
            stvBuyGold.setOnClickListener {
                listener?.byGold()
            }
            stvBuyMember.setOnClickListener {
                listener?.byMember()
            }
            ivCancel.setOnClickListener {
                context.onBackPressed()
            }
        }
        dialog.setOnCancelListener {
            dialog.dismiss()
            context.onBackPressed()
        }
        dialog.show()
        return dialog
    }

    interface BuyGoldListener {
        fun buyGold()
    }

    fun createNoGoldDialog(context: Activity, listener: BuyGoldListener? = null): Dialog {
        val dialog = Dialog(context, R.style.member_dialog)
        val bind = MemberNoGoldDialogBinding.inflate(LayoutInflater.from(context))
        dialog.setContentView(bind.root)
        dialog.immersiveStatusBar()
        dialog.setLightStatusBar(true)
        bind.apply {
            tvLeft.setOnClickListener {
                dialog.dismiss()
            }
            tvRight.setOnClickListener {
                listener?.buyGold()
            }
        }
        dialog.show()
        return dialog
    }
}