package com.at.video.member.ui.buy

import android.annotation.SuppressLint
import android.widget.ImageView
import android.widget.TextView
import com.at.video.member.R
import com.at.video.member.entity.GoldsItem
import com.at.video.member.stampToData
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.utils.toArgb

/**
 * @Create_time: 2022/5/5 16:55
 * @Description:
 */

class MineBuyAdapter : BaseQuickAdapter<GoldsItem, BaseViewHolder>(R.layout.member_item_mine_buy) {
    @SuppressLint("SetTextI18n")
    override fun convert(holder: BaseViewHolder, item: GoldsItem) {
        val subIcon = holder.getView<ImageView>(R.id.iv_sub_icon)
        val icon = holder.getView<ImageView>(R.id.div_icon)
        val tag = holder.getView<TextView>(R.id.stv_tag)
        val title = holder.getView<TextView>(R.id.stv_title)
        val time = holder.getView<TextView>(R.id.stv_pay_time)
        val sum = holder.getView<TextView>(R.id.stv_sum)
        holder.getView<TextView>(R.id.tv_buy_status).setTextColor(StyleUtils.getPrimaryColor().toArgb())
        time.text = item.createdAt.stampToData()
        sum.text = "${item.number} 金币"
        when (item.use) {
            1 -> { // vip
                subIcon.setImageResource(R.drawable.member_ic_vip_sub)
                icon.setImageResource(R.drawable.member_ic_vip)
                tag.text = "VIP会员"
                title.text = "购买时长: ${item.days}天"
            }
            2 -> { // 影片
                subIcon.setImageResource(R.drawable.member_ic_video_sub)
                icon.setImageResource(R.drawable.member_ic_video)
                tag.text = "点播服务"
                title.text = item.name
            }
            3 -> { // 小说
                subIcon.setImageResource(R.drawable.member_ic_novel_sub)
                icon.setImageResource(R.drawable.member_ic_novel)
                tag.text = "章节订阅"
                title.text = item.name
            }
            4 -> { // 图集
                subIcon.setImageResource(R.drawable.member_ic_atlas_sub)
                icon.setImageResource(R.drawable.member_ic_atlas)
                tag.text = "购买图集"
                title.text = item.name
            }
        }
    }
}
