package com.at.video.member.ui.member

import android.graphics.Paint
import android.widget.TextView
import com.at.video.member.R
import com.at.video.member.entity.ComboInfo
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import java.math.RoundingMode
import java.text.DecimalFormat

/**
 * @Create_time: 2022/4/28 16:30
 * @Description: 会员
 */

class MemberAdapter: BaseQuickAdapter<ComboInfo, BaseViewHolder>(R.layout.member_item_member) {

    init {
        addChildClickViewIds(R.id.sb_pay)
    }

    override fun convert(holder: BaseViewHolder, item: ComboInfo) {
        holder.setText(R.id.stv_name, item.name)
            .setText(R.id.tv_desc, item.des)
        holder.setText(R.id.tv_original_price, "${item.originalPrice/100}")
        holder.setText(R.id.tv_current_price, "${item.price/100}")
        holder.getView<TextView>(R.id.tv_original_price).paint.flags = Paint.STRIKE_THRU_TEXT_FLAG or Paint.ANTI_ALIAS_FLAG
    }

    private fun getFloatNoMoreThanTwoDigits(number: Float): String {

        return String.format("%.2f",number)
    }
}