package com.at.video.member.ui.member

import android.graphics.Color
import android.graphics.Paint
import android.view.View
import android.widget.TextView
import com.at.video.member.R
import com.at.video.member.entity.ComboInfo
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.utils.toArgb
import com.video.module_widget.widget.ShapeLinearLayoutExt
import java.math.RoundingMode
import java.text.DecimalFormat

/**
 * @Create_time: 2022/4/28 16:30
 * @Description: 会员
 */

class MemberAdapterNew: BaseQuickAdapter<ComboInfo, BaseViewHolder>(R.layout.member_item_member_new) {

    private var mPosition = 0

    override fun convert(holder: BaseViewHolder, item: ComboInfo) {
        holder.setText(R.id.stv_name, item.name)
        holder.setText(R.id.tv_original_price, "${item.originalPrice/100}")
        holder.setText(R.id.tv_current_price, "${item.price/100}")
        holder.getView<TextView>(R.id.tv_original_price).paint.flags = Paint.STRIKE_THRU_TEXT_FLAG or Paint.ANTI_ALIAS_FLAG
       val root =  holder.getView<ShapeLinearLayoutExt>(R.id.ll_root)
        changeStyle(root,holder)
    }

    override fun convert(holder: BaseViewHolder, item: ComboInfo, payloads: List<Any>) {
        val root =  holder.getView<ShapeLinearLayoutExt>(R.id.ll_root)
        changeStyle(root,holder)
    }


    private fun changeStyle(root:ShapeLinearLayoutExt,holder:BaseViewHolder){
        if(mPosition == holder.bindingAdapterPosition){
            root.setBorderWidth(2)
            root.setBorderColor(StyleUtils.getPrimaryColor().toArgb())
            root.setBackgroundColor(StyleUtils.getPrimaryColor().toArgb(0.3))
            root.setShapeShadowColorAndSize(StyleUtils.getPrimaryColor().toArgb(0.3),20)
            holder.setTextColor(R.id.stv_name,StyleUtils.getPrimaryColor().toArgb())
            holder.setTextColor(R.id.tv_current_price,StyleUtils.getPrimaryColor().toArgb())
            holder.setTextColor(R.id.tv_price_symbol,StyleUtils.getPrimaryColor().toArgb())
        }else{
            root.setBackgroundColor(Color.WHITE)
            root.setShapeShadowColorAndSize("rgba(85,85,85,0.09)".toArgb(),20)
            root.setBorderWidth(0)
            holder.setTextColor(R.id.stv_name,Color.BLACK)
            holder.setTextColor(R.id.tv_current_price,Color.BLACK)
            holder.setTextColor(R.id.tv_price_symbol,Color.BLACK)
        }
        root.reBuilder()
    }

    fun setIndex(position: Int){
        val prePosition = mPosition
        mPosition = position
        notifyItemChanged(prePosition,"notify")
        notifyItemChanged(mPosition,"notify")
    }
}