package com.at.video.export.mine

import android.os.UserManager
import com.melancholy.router.api.facade.template.IProvider
import com.melancholy.router.api.launcher.Router
import kotlinx.coroutines.flow.StateFlow

/**
 * @Create_time: 2022/5/20 11:22
 * @Description: 为其他模块提供对外数据
 */

interface IMineService: IProvider {

    companion object {
        @JvmStatic
        fun getMineService(): IMineService {
            return Router.getInstance().build("/mine/MineService").navigation() as IMineService
        }
    }

    //获取用户信息
    fun getUser(): StateFlow<IUser?>

    //获取token信息
    fun getToken(): StateFlow<IToken?>

}