package com.at.video.mine

import java.math.RoundingMode
import java.text.DecimalFormat
import java.util.*

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/6/27 下午2:39
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/6/27 下午2:39
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
object TimeUtils {
    fun stringForTime(timeMs: Long): String? {
        if (timeMs <= 0 || timeMs >= 24 * 60 * 60 * 1000) {
            return "00:00"
        }
        val totalSeconds = timeMs / 1000
        val seconds = (totalSeconds % 60).toInt()
        val minutes = (totalSeconds / 60 % 60).toInt()
        val hours = (totalSeconds / 3600).toInt()
        val stringBuilder = StringBuilder()
        val mFormatter = Formatter(stringBuilder, Locale.getDefault())
        return if (hours > 0) {
            mFormatter.format("%d:%02d:%02d", hours, minutes, seconds).toString()
        } else {
            mFormatter.format("%02d:%02d", minutes, seconds).toString()
        }
    }
    fun getFloatNoMoreThanTwoDigits(number: Float): String {
        val format = DecimalFormat("#.##")
        format.roundingMode = RoundingMode.HALF_UP
        return format.format(number)
    }
}