package com.at.video.mine.entity

import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.JsonClass

/**
 * @Create_time: 2022/6/14 10:01
 * @Description: app版本信息
 */

@JsonClass(generateAdapter = true)
data class AppVersionInfo(
    val id: Int = -1,
    val name: String? = "",
    var appName: String? = "",
    val sourceType: Int = 1,
    val size:String? ="",
    val packageName:String? ="",
    val forciblyUpdate:Boolean = false,
    val downUrl:String? = "",
    val code:Int = 0,
    val updatedAt:String? = "",
    val updateLog:String? = ""
): Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readInt(),
        parcel.readString()?: "",
        parcel.readString()?: "",
        parcel.readInt(),
        parcel.readString()?: "",
        parcel.readString()?: "",
        parcel.readBoolean(),
        parcel.readString()?: "",
        parcel.readInt(),
        parcel.readString()?: "",
        parcel.readString()?: "",

        )

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(id)
        parcel.writeString(name)
        parcel.writeString(appName)
        parcel.writeInt(sourceType)
        parcel.writeString(size)
        parcel.writeString(packageName)
        parcel.writeBoolean(forciblyUpdate)
        parcel.writeString(downUrl)
        parcel.writeInt(code)
        parcel.writeString(updatedAt)
        parcel.writeString(updateLog)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<AppVersionInfo> {
        override fun createFromParcel(parcel: Parcel): AppVersionInfo {
            return AppVersionInfo(parcel)
        }

        override fun newArray(size: Int): Array<AppVersionInfo?> {
            return arrayOfNulls(size)
        }
    }
}