package com.at.video.mine.entity

import com.chad.library.adapter.base.entity.MultiItemEntity
import com.squareup.moshi.JsonClass

/**
 * @Create_time: 2022/5/28 15:25
 * @Description: 收藏信息
 */

@JsonClass(generateAdapter = true)
data class CollectInfo(
    val area: String?,
    val categoryName: String?,
    val chargingCoin: Int?,
    val chargingState: Int?,
    val collection: Int?,
    val filmTheme: String?,
    val heat: Int?,
    val id: Int,
    val intro: String?,
    val isCollection: Boolean?,
    val isPraise: Boolean?,
    val label: String?,
    val name: String?,
    val title: String?,
    val numEpisodes: Int?,
    val playLines: Any?,
    val praise: Int?,
    val score: String?,
    val showDate: String?,
    val state: Int?,
    val updateDate: Int?,
    val verticalCover: String?,
    val isSelected: Boolean = false,
    val chapter: Int?,
    val resourceType: Int = if (chapter != null) 2 else 3,
    override val itemType: Int = chargingState ?: 1
) : MultiItemEntity

@JsonClass(generateAdapter = true)
data class CollectList(
    val list:List<CollectBean>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?
){
    fun msg():String = when(code){
        401->"未登录"
        else -> message?:""
    }

    fun success():Boolean = code ==200
}

@JsonClass(generateAdapter = true)
data class CollectBean(
    val belong_app_id: String?,
    val cover: String?,
    val created_at: String?,
    val id: String?,
    val name: String?,
    val resource_id: String?,
    val type: Int?,
    val updated_at: String?,
    var is_selected:Boolean = false,
    val user_id: String?, override val itemType: Int = 1
):MultiItemEntity