package com.at.video.mine.entity

import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class HistoryList(
    val day: List<ChapterInfo>,
    val history: List<HistoryBean>
)

@JsonClass(generateAdapter = true)
data class HistoryInfo(
    val list:List<HistoryBean>?,
    val total:String?,
    val code:Int = 200,
    val reason:String?,
    val message:String?
){
    fun msg():String = when(code){
        401->"未登录"
        else -> message?:""
    }

    fun success():Boolean = code ==200
}

@JsonClass(generateAdapter = true)
data class HistoryBean(
    val belong_app_id: String?,
    val cover: String?,
    val created_at: String?,
    val episode: String?,
    val id: String?,
    val name: String?,
    val percentage: String?,
    val progress: String?,
    val resource_id: String?,
    val type: Int?,
    val updated_at: String?,
    val user_id: String?,
    var is_selected:Boolean = false,
    var hisTag:String = ""
)
