package com.at.video.mine.entity

import com.at.video.export.mine.IUser
import com.squareup.moshi.JsonClass

/**
 * @Create_time: 2022/5/20 13:17
 * @Description: 用户信息
 */

@JsonClass(generateAdapter = true)
data class UserInfo(
    val activeTime: Long,
    val avatar: String,
    val birthday: Long,
    val channel: Int,
    val consumption: Int,
    val createdAt: Long,
    val editAddr: String,
    val email: String,
    val expirationTime: Long,
    val gender: Int,
    val gold: Long,
    val id: Long,
    val lastLoginTime: Long,
    val loginNumber: Int,
    val nickname: String,
    val personalProfile: String,
    val phoneNumber: String?,
    val registeredAddr: String,
    val registeredIp: String,
    val signInDays: Int,
    //1：普通会员，2：VIP会员
    var type: Int,
    val updatedAt: Long,
    val username: String,
): IUser {

    override fun getUserId(): String = ""
    override fun getUserName(): String = username

    override fun getUserNickname(): String = nickname

    override fun getUserAvatar(): String = avatar

    override fun getUserAccount(): String = username

    override fun getPhoneCountryCode(): String  = ""

    override fun getUserPhoneNumber(): String? = phoneNumber

    override fun getUserEmail(): String = email

    override fun getUserBirthday(): String = ""

    override fun getUserGold(): String = ""

    override fun getUserGender(): Int = gender

    override fun getUserAddress(): String = editAddr

    override fun getUserExpirationTime(): Long = expirationTime

    override fun getUserActiveTime(): String = ""

    override fun getUserLastLoginTime(): String = ""

    override fun isMember(): Boolean = type == 2

    override fun getUserConsumption(): String = ""

}