package com.at.video.mine.entity

import com.at.video.export.mine.IToken
import com.at.video.export.mine.IUser
import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class UserLogin(
    val active_time: String?,
    var avatar: String?,
    val belong_app_id: String?,
    val belong_app_name: String?,
    val belong_webmaster_id: String?,
    val belong_webmaster_name: String?,
    val created_at: String?,
    val email: String?,
    val gold_coin_balance: String?,
    val id: String?,
    val is_normal_account: Int?,
    val is_normal_transaction: Int?,
    val is_online: Int?,
    val is_vip: Int?,
    val login_addr: String?,
    val login_browser_version: String?,
    val login_device_name: String?,
    val login_ip: String?,
    val login_source: Int?,
    val login_system_version: String?,
    val login_time: String?,
    val login_times: String?,
    var nickname: String?,
    val phone_number: String?,
    val registered_source: Int?,
    val updated_at: String?,
    val username: String?,
    val vip_expire_date: String?,
    val mobile_country_code: String?
)

@JsonClass(generateAdapter = true)
data class UserLoginInfo(
    val session: String?,
    val user: UserLogin?,
    val user_additional: UserAdditional?,
    val code: Int = 200,
    val reason: String?,
    val message: String?
) : IUser, IToken {
    fun msg(): String = when (code) {
        401 -> "未登录"
        else -> message ?: ""
    }

    fun success(): Boolean = code == 200
    override fun getUserId(): String = user_additional?.user_id!!

    override fun getUserName(): String = user?.username.toString()

    override fun getUserNickname(): String = user?.nickname.toString()

    override fun getUserAvatar(): String = user?.avatar.toString()

    override fun getUserAccount(): String = user?.username.toString()

    override fun getPhoneCountryCode(): String? = user?.mobile_country_code

    override fun getUserPhoneNumber(): String? = user?.phone_number

    override fun getUserEmail(): String = user?.email.toString()

    override fun getUserBirthday(): String = user_additional?.birthday.toString()

    override fun getUserGold(): String = user?.gold_coin_balance.toString()
    override fun getUserGender(): Int = user_additional?.gender!!

    override fun getUserAddress(): String = user_additional?.location.toString()

    override fun getUserExpirationTime(): Long = 0

    override fun getUserActiveTime(): String = user?.active_time.toString()

    override fun getUserLastLoginTime(): String = user?.login_time.toString()

    override fun isMember(): Boolean = user?.is_vip == 1

    override fun getUserConsumption(): String = user_additional?.vip_buy_cost.toString()

    override fun getUserToken(): String = session.toString()

    override fun getUserRefreshToken(): String = session.toString()
}

@JsonClass(generateAdapter = true)
data class UserAdditional(
    var birthday: String?,
    val created_at: String?,
    var gender: Int?,
    val gold_coin_gift: String?,
    val gold_coin_recharge: String?,
    val id: String?,
    var location: String?,
    val registered_addr: String?,
    val registered_browser_version: String?,
    val registered_device_name: String?,
    val registered_ip: String?,
    val registered_system_version: String?,
    val updated_at: String?,
    val user_id: String?,
    val vip_buy_cost: String?,
    val vip_time_gift: String?
)
