package com.at.video.mine.http.interceptor

import com.at.common.global.Constants
import com.at.video.export.mine.IToken
import com.at.video.mine.manager.UserManager
import com.melancholy.network.INetworkInterceptor
import com.melancholy.network.utils.Utils
import com.melancholy.register.annotation.RegisterService
import okhttp3.*

/**
 * @Create_time: 2022/5/20 11:18
 * @Description: 添加token拦截器
 */

@RegisterService(serviceClass = INetworkInterceptor::class)
class TokenInterceptor: INetworkInterceptor {

    override fun priority(): Int = 1

    override fun intercept(chain: Interceptor.Chain): Response {
        val tokenInfo: IToken? = UserManager.instance.tokenFlow.value
        var request: Request = chain.request()
        val newRequestBuilder = request.newBuilder()

        if(tokenInfo != null) {
            val headers: Headers = request.headers.newBuilder()
                .add("Authorization", tokenInfo.getUserToken()).build()
//            request = request.newBuilder().headers(headers).build()
            newRequestBuilder.headers(headers)
        }
        val method = request.method
        var url = request.url.newBuilder().build()
//       if(method == "POST"){
//           val body = request.body
//           if(body is FormBody){
//               newRequestBuilder.url(url)
//               val formBody:FormBody = request.body as FormBody
//               val builder = FormBody.Builder()
//               for (i in 0 until formBody.size){
//                   builder.add(formBody.encodedName(i),formBody.encodedValue(i))
//               }
//               builder.add("belong_app_id",Constants.APP_ID)
//               newRequestBuilder.post(builder.build())
//           }
//       }else
        if("GET" == method){
             url = request.url.newBuilder().addQueryParameter("belong_app_id",Constants.APP_ID).build()
            newRequestBuilder.url(url)
        }
//        return chain.proceed(request)
        return chain.proceed(newRequestBuilder.build())
    }

}