package com.at.video.mine.other

import android.text.TextPaint
import android.text.style.ClickableSpan
import android.util.Log
import android.view.View
import androidx.core.content.ContextCompat
import com.at.common.global.Constants
import com.at.video.mine.R
import com.melancholy.router.api.launcher.Router
import com.melancholy.utils.AppInstance
import com.melancholy.widget.fixtouch.ITouchableSpan
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.utils.toArgb

/**
 * @Create_time: 2022/6/18 14:21
 * @Description: 协议点击事件
 */

class AgreementSpan: ClickableSpan, ITouchableSpan {
    private val mAgreement: String

    constructor(agreement: String, title: String?) {
        mAgreement = richText(agreement, title)
    }

    //处理富文本
    private fun richText(body: String, title: String?): String {
        if (body.contains("<body>")&&body.contains("</body>")){
            return body
        }
        val head = ("<head>"
                + "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=yes\"> "
                + "<style>img{max-width: 100%; width:auto; height:auto;}</style>"
                + "<style>table{max-width: 100%; width:auto; height:auto;}</style>"
                +"<title>$title</title>"
                + "</head>")
       val res = body.replace("\n","<br>")
        return "<html>$head<body>$res</body></html>"
    }

    override fun onClick(widget: View) {
        Log.e("Click","span")
        Router.getInstance().build("/webview/WebViewActivity")
            //.withString(Constants.KEY_DATA, data.jumpAddr)
            .withString(Constants.KEY_DATA_1, mAgreement)
            .navigation()
    }

    override fun setPressed(pressed: Boolean) {

    }

    override fun updateDrawState(ds: TextPaint) {
        //颜色
//        ds.color = ContextCompat.getColor(AppInstance.getApplication(), R.color.color_FF2167FF)
        ds.color = StyleUtils.getPrimaryColor().toArgb()
        //去掉下划线
        ds.isUnderlineText = false
    }

}