package com.at.video.mine.router

import android.content.Context
import com.at.video.export.mine.IMineService
import com.melancholy.router.annotation.annotation.Interceptor
import com.melancholy.router.api.facade.Postcard
import com.melancholy.router.api.facade.callback.InterceptorCallback
import com.melancholy.router.api.facade.template.IInterceptor
import com.melancholy.router.api.launcher.Router

/**
 * @Create_time: 2022/5/23 21:46
 * @Description: 登陆拦截器
 */

@Interceptor(priority = 1)
class LoginInterceptor : IInterceptor {

    override fun init(context: Context) {
    }

    override fun process(postcard: Postcard, callback: InterceptorCallback) {
        if (postcard.extra == 10086) {
            // 需要登录
            // 判断是否登录，如果没有登录就跳转到登录页面
            if (IMineService.getMineService().getUser().value != null) {
                callback.onContinue(postcard)
            } else {
                callback.onInterrupt(null)
                Router.getInstance().build("/mine/LoginActivity")
                    .with(postcard.getExtras())
                    .withString("path", postcard.path)
                    .navigation()
            }
        } else {
            // 不需要登录
            callback.onContinue(postcard)
        }
    }
}
