package com.at.video.mine.ui.invitation

import android.graphics.Bitmap
import android.graphics.Color
import android.os.Bundle
import android.view.View
import com.at.common.binding.BaseBindingActivity
import com.at.common.immersiveStatusBar
import com.at.common.setLightStatusBar
import com.at.common.utils.ToastUtils
import com.at.module_export_main.IMainService
import com.at.video.mine.EncodingUtils
import com.at.video.mine.R
import com.at.video.mine.databinding.MineActivityInvitationBinding
import com.at.video.mine.ui.mine.utils.saveToAlbum
import com.melancholy.router.annotation.annotation.Route
import com.melancholy.utils.ClipboardUtils
import com.melancholy.utils.DensityUtils
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.utils.toArgb

/**
 * @Create_time: 2022/5/5 19:40
 * @Description: 邀请好友
 */

@Route(path = "/mine/InvitationActivity")
class InvitationActivity : BaseBindingActivity<MineActivityInvitationBinding>(),
    View.OnClickListener {

    override fun createViewBinding(): MineActivityInvitationBinding {
        return MineActivityInvitationBinding.inflate(layoutInflater)
    }

    private var sysShareAddr: String? = null
    private var bitmap:Bitmap?=null
    override fun initialize(savedInstanceState: Bundle?) {
//        sysShareAddr = IMainService.getMainService().getSysConfig().getConfigShareAddr()
        sysShareAddr = "www.baidu.com"
        requireTitleBar().apply {
            setBackgroundColor(Color.WHITE)
            addBackButton(Color.BLACK)
            setTitleColor(Color.BLACK)
            setTitle("邀请好友")
        }

        requireBinding().apply {
            sbSave.setOnClickListener(this@InvitationActivity)
            sbShare.setOnClickListener(this@InvitationActivity)
            sbSave.setTextColor(StyleUtils.getPrimaryColor().toArgb())
            sbShare.setTextColor(StyleUtils.getPrimaryColor().toArgb())
            sbSave.setShapeStrokeColor(StyleUtils.getPrimaryColor().toArgb())
            sbShare.setShapeStrokeColor(StyleUtils.getPrimaryColor().toArgb())
            sbSave.reBuilder()
            sbShare.reBuilder()
            sysShareAddr?.apply {
                // tvBottomContent.text = "访问 $this 下载app"
                bitmap = EncodingUtils.createQRCode(
                    this,
                    DensityUtils.dp2px(this@InvitationActivity, 500F),
                    DensityUtils.dp2px(this@InvitationActivity, 500F),
                    null
                )
                requireBinding().ivErcode.setImageBitmap(bitmap)
            }
        }
    }

    override fun loadData() {

    }

    override fun immersiveBar() {
        immersiveStatusBar()
        setLightStatusBar(true)
    }

    override fun onClick(p0: View) {
        when (p0.id) {
            R.id.sb_save -> {
                val saveToAlbum = bitmap?.saveToAlbum(
                    this,
                    "invitation_${System.currentTimeMillis()}.png"
                )
                if (saveToAlbum != null) {
                    ToastUtils.show("保存成功,请到本地图库查阅")
                } else {
                    ToastUtils.show("保存失败")
                }
            }
            R.id.sb_share -> {
                ClipboardUtils.copyText(this,sysShareAddr?:"")
                ToastUtils.show("复制链接成功")
            }
        }
    }
}