package com.at.video.mine.ui.mine

import android.app.Application
import androidx.lifecycle.viewModelScope
import com.at.common.global.CacheHelper
import com.at.common.mvi.BaseAndroidViewModel
import com.at.common.mvi.IUiEffect
import com.at.common.mvi.IUiEvent
import com.at.common.mvi.IUiState
import com.at.video.export.mine.IMineService
import com.at.video.mine.http.ApiService
import com.at.video.mine.manager.UserManager
import com.melancholy.network.ApiFactory
import dagger.hilt.android.lifecycle.HiltViewModel
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch
import java.util.*
import javax.inject.Inject

/**
 * @Create_time: 2022/4/27 13:38
 * @Description:
 */

data class MineUiState(
    val msgCount:Int = 0
): IUiState

sealed class MineUiEvent: IUiEvent {
    object UserInfo: MineUiEvent()
    object GetMeg:MineUiEvent()
    object InitMsgCount:MineUiEvent()
}

sealed class MineUiEffect: IUiEffect {

}

@HiltViewModel
class MineViewModel @Inject constructor(application: Application):
    BaseAndroidViewModel<MineUiState, MineUiEvent, MineUiEffect>(application) {

    override fun providerInitialState(): MineUiState {
        return MineUiState()
    }

    override fun handleEvent(event: MineUiEvent) {
        when(event) {
            is MineUiEvent.UserInfo -> getUserinfo()
            is MineUiEvent.GetMeg -> getLatestMessage()
            is MineUiEvent.InitMsgCount->setState { copy(msgCount=0) }
        }
    }

    /**
     * 获取用户信息
     */
    private fun getUserinfo() {
//        val id: Long = IMineService.getMineService().getUser().value?.getUserId() ?: return
//        viewModelScope.launch(Dispatchers.IO) {
//            val data = ApiFactory.getInstance().create(ApiService::class.java).userinfo(id)
//            if(data.success() && data.data != null) {
//                UserManager.instance.updateUser(data.data!!)
//            }
//        }
    }

    private fun serviceLogin(){
        viewModelScope.launch {
            val map: MutableMap<String, Any> = mutableMapOf()
            val usr = IMineService.getMineService().getUser().value
            map["visitor_id"] = usr?.getUserId().toString()
            map["name"] = usr?.getUserName()!!
            val res =ApiFactory.getInstance().create(ApiService::class.java).serviceLogin(map)
            if(res.code == 6200 &&res.data!=null){
                val msg = res.data!!
//                getLatestMessage(msg.visitor_id!!,msg.kefu_id!!,msg.kefu_name!!)
            }
        }
    }

    private fun getLatestMessage(){
        val kefuId = CacheHelper.getInstance().getString("shared_kefu_id", "")
        val kefuName = CacheHelper.getInstance().getString("shared_kefu_name", "")
        if(kefuId == null)return
//        val id: Long = IMineService.getMineService().getUser().value?.getUserId() ?: return
//        viewModelScope.launch {
//            val map: MutableMap<String, Any> = mutableMapOf()
//            val usr = IMineService.getMineService().getUser().value
//            map["visitor_id"] = id
//            map["kefu_id"] = kefuId
//            map["kefu_name"] = kefuName!!
//            map["client"] = true
//            map["visitor_name"] = usr?.getUserName()!!
//            val res = ApiFactory.getInstance().create(ApiService::class.java).getMsgCount(map)
//
//            if(res.code == 6200 &&res.data!=null){
//                setState { copy(msgCount = res.data!!.total) }
//            }else{
//                setState { copy(msgCount = 0) }
//            }
//        }
    }
}