package com.at.video.player.custom

import android.content.Context
import android.view.View
import androidx.recyclerview.widget.RecyclerView
import com.at.video.player.R
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.lxj.xpopup.core.PositionPopupView

/**
 * @Create_time: 2022/4/24 15:51
 * @Description:
 */

class DefinitionPopup(context: Context): PositionPopupView(context), OnItemClickListener {
    private lateinit var mRecyclerView: RecyclerView
    private val mAdapter: DefinitionAdapter = DefinitionAdapter()

    override fun getImplLayoutId(): Int {
        return R.layout.player_custom_definition
    }

    override fun onCreate() {
        super.onCreate()
        mRecyclerView = findViewById(R.id.recycler_view)
        mRecyclerView.setHasFixedSize(true)
        mRecyclerView.adapter = mAdapter
        mAdapter.setOnItemClickListener(this)
    }

    fun setData(data: MutableList<String>) {
        mAdapter.setNewInstance(data)
    }

    class DefinitionAdapter: BaseQuickAdapter<String,
            BaseViewHolder>(R.layout.player_custom_item_definition) {

        override fun convert(holder: BaseViewHolder, item: String) {
            holder.setText(R.id.tv_definition, item)
                .setGone(R.id.iv_checked, false)
        }

        override fun convert(holder: BaseViewHolder, item: String, payloads: List<Any>) {

        }

    }

    override fun onItemClick(adapter: BaseQuickAdapter<*, *>, view: View, position: Int) {

    }
}