package com.at.video.player.custom;

import com.liulishuo.filedownloader.BaseDownloadTask;
import com.liulishuo.filedownloader.FileDownloadListener;

public class DownloadSpecifiedLocationBlockListener extends FileDownloadListener {

    public DownloadSpecifiedLocationBlockListener(DownloadListener downloadListener) {
        this.downloadListener = downloadListener;
    }

    public interface DownloadListener {
        void completed(BaseDownloadTask task);

        void error(BaseDownloadTask task, Throwable e);
    }

    private DownloadListener downloadListener;

    public DownloadListener getDownloadListener() {
        return downloadListener;
    }

    public void setDownloadListener(DownloadListener downloadListener) {
        this.downloadListener = downloadListener;
    }

    @Override
    protected void pending(BaseDownloadTask task, int soFarBytes, int totalBytes) {

    }

    @Override
    protected void progress(BaseDownloadTask task, int soFarBytes, int totalBytes) {

    }

    @Override
    protected void completed(BaseDownloadTask task) {
        if (downloadListener != null)
            downloadListener.completed(task);
    }

    @Override
    protected void paused(BaseDownloadTask task, int soFarBytes, int totalBytes) {

    }

    @Override
    protected void error(BaseDownloadTask task, Throwable e) {
        if (downloadListener != null)
            downloadListener.error(task, e);
    }

    @Override
    protected void warn(BaseDownloadTask task) {

    }
}
