/*
 * Copyright (C) 2015 Zhang Rui <bbcallen@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.at.video.player.custom;

import java.io.IOException;

import cn.jzvd.IReadData;
import tv.danmaku.ijk.media.player.misc.IMediaDataSource;

public class FileMediaDataSource implements IMediaDataSource {
    private IReadData mIReadData;

    public FileMediaDataSource(IReadData mIReadData) throws IOException {
        this.mIReadData = mIReadData;
    }

    @Override
    public int readAt(long position, byte[] buffer, int offset, int size) throws IOException {
        return mIReadData.readData(position, buffer, offset, size);
    }

    @Override
    public long getSize() throws IOException {
         return mIReadData.getSize();
    }

    @Override
    public void close() throws IOException {
        if (mIReadData != null) {
            mIReadData.close();
        }
    }
}
