package com.at.video.player.custom

import android.content.Context
import android.graphics.Color
import android.util.TypedValue
import android.view.Gravity
import android.view.View
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.at.video.player.R
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.lxj.xpopup.core.PositionPopupView

/**
 * @Create_time: 2022/4/25 10:00
 * @Description:
 */

class SubtitlesPopup(context: Context): PositionPopupView(context), OnItemClickListener {

    private lateinit var mRecyclerView: RecyclerView
    private val mAdapter: SubtitlesAdapter = SubtitlesAdapter()

    override fun getImplLayoutId(): Int {
        return R.layout.player_custom_subtitles
    }

    override fun onCreate() {
        super.onCreate()
        mRecyclerView = findViewById(R.id.recycler_view)
        mRecyclerView.setHasFixedSize(true)
        mRecyclerView.adapter = mAdapter
        mAdapter.setOnItemClickListener(this)
        val text = TextView(context)
        text.setTextSize(TypedValue.COMPLEX_UNIT_PX, resources.getDimensionPixelSize(com.at.common.R.dimen.sp_12).toFloat())
        text.setTextColor(Color.WHITE)
        text.text = "字幕设置"
        text.gravity = Gravity.CENTER_VERTICAL
        text.setPadding(resources.getDimensionPixelSize(com.at.common.R.dimen.dp_16), 0, 0, 0)
        val params: RecyclerView.LayoutParams = RecyclerView.LayoutParams(
            RecyclerView.LayoutParams.MATCH_PARENT, resources.getDimensionPixelSize(com.at.common.R.dimen.dp_44))
        text.layoutParams = params
        mAdapter.addHeaderView(text)
    }

    fun setData(data: MutableList<String>) {
        mAdapter.setNewInstance(data)
    }

    class SubtitlesAdapter: BaseQuickAdapter<String,
            BaseViewHolder>(R.layout.player_custom_item_subtitles) {

        override fun convert(holder: BaseViewHolder, item: String) {
            holder.setText(R.id.tv_subtitles, item)
                .setGone(R.id.iv_checked, true)
        }

        override fun convert(holder: BaseViewHolder, item: String, payloads: List<Any>) {

        }
    }

    override fun onItemClick(adapter: BaseQuickAdapter<*, *>, view: View, position: Int) {

    }
}