package com.at.video.player.entity

import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class VideoBean(
    val id: String?,
    val name: String?,
    val name_alias: String?,
    val categ_id: String?,
    val categ_name: String?,
    val subcateg_id: String?,
    val subcateg_name: String?,
    val introduction: String?,
    val cover_horizontal: String?,
    val cover_vertical: String?,
    val Origin: String?,
    val status: Int?,
    val area: String?,
    val area_id: String?,
    val year: String?,
    val lang: String?,
    val duration: String?,
    val publish_status: String?,
    val actors: String?,
    val directors: String?,
    val release_date: String?,
    val episode: String?,
    val episode_total: String?,
    val keyword: String?,
    val name_eng: String?,
    val note: String?,
    val play_url: String?,
    val price: String?,
    val price_type: String?,
    val score_douban: String?,
    val score_imdb: String?,
    val score: String?,
    val popularity: String?,
    val site_id: String?,
    val tags: String?,
    val highlight: String?,
    var is_collect: Int = 2,
    var is_star: Boolean = false,
    val code: Int = 200,
    val reason: String?,
    val message: String?,
) {
    fun msg(): String = when (code) {
        401 -> "未登录"
        else -> "成功"
    }

    fun success(): Boolean = code == 200
}


@JsonClass(generateAdapter = true)
data class VideoDetailBean(
    val video: VideoBean?,
    val code: Int = 200,
    val reason: String?,
    val message: String?,
    val like_list: VideoList?,
    val extra: Extra?,
    val watch_history: WatchHistorys?,
    val status: VideoStatus?
) {
    fun msg(): String = when (code) {
        401 -> "未登录"
        else -> "成功"
    }

    fun success(): Boolean = code == 200
}

@JsonClass(generateAdapter = true)
data class WatchHistorys(
    val belong_app_id: String?,
    val cover: String?,
    val created_at: String?,
    var episode: String?,
    val id: String?,
    val name: String?,
    var percentage: String?,
    val price: String?,
    val price_type: String?,
    var progress: String?,
    val resource_id: String?,
    val type: Int?,
    val updated_at: String?,
    val user_id: String?,
    val play_index: String?
)

@JsonClass(generateAdapter = true)
data class Extra(
    val id: String?,
    val res_id: String?,
    val module: Int,
    val pop_star: String?,
    val pop_score: String?,
    val pop_total: String?,
    val pop_view: String?,
    val pop_like: String?,
    val pop_dislike: String?,
    val pop_collection: String?,
    val pop_share_count: String?,
    val created_at: String?,
    val updated_at: String?
)

@JsonClass(generateAdapter = true)
data class LineBean(
    val number: String?,
    val name: String?,
    val urls: List<VideoUrl>?
)

@JsonClass(generateAdapter = true)
data class VideoUrl(
    val name: String?,
    val url: String?,
    val order: String?,
    val seed_mark: String?
)

@JsonClass(generateAdapter = true)
data class VideoList(
    val list: List<VideoBean>?,
    val total: String?,
    val code: Int = 200,
    val reason: String?,
    val message: String?,
) {
    fun msg(): String = when (code) {
        401 -> "未登录"
        else -> "成功"
    }

    fun success(): Boolean = code == 200
}

@JsonClass(generateAdapter = true)
data class ActorBean(
    val list: List<RoleBean>?,
    val total: String?,
    val code: Int = 200,
    val reason: String?,
    val message: String?
) {
    fun msg(): String = when (code) {
        401 -> "未登录"
        else -> "成功"
    }

    fun success(): Boolean = code == 200
}


@JsonClass(generateAdapter = true)
data class Video(
    val updated_at: String?,
    val album: String?,
    val categ_id: String?,
    val categ_name: String?,
    val cover: String?,
    val id: String?,
    val name: String?,
    val popularity: String?,
    val price: List<String>?,
    val score: Int?,
    val status: Int?,
    val subcateg_id: String?,
    val subcateg_name: String?,
    val album_ids: List<String>?,
    val price_type: List<String>?
)

@JsonClass(generateAdapter = true)
data class VideoStatus(
    val is_like: Int,
    val is_collect: Int,
    val is_watch: Int
)