package com.at.video.player.entity

import com.chad.library.adapter.base.entity.MultiItemEntity
import com.squareup.moshi.JsonClass

/**
 * @Create_time: 2022/5/24 19:29
 * @Description:
 */

@JsonClass(generateAdapter = true)
data class VideoInfo(
    val id: Int = -1,
    val name: String? = null,
    val categoryName: String? = null,
    val filmTheme: String? = null,
    val area: String? = "",
    val score: Float? = 0.0f,
    val heat: Int? = 0,
    val praise: Long? = 0,
    var isPraise: Boolean = false,
    var isCollection: Boolean = false,
    val collection: Long? = 0,
    val state: Int? = 0,
    val label: String? = null,
    val chargingCoin: Int? = 0,
    val verticalCover: String? = null,
    val updateDate: String? = null,
    val showDate: String? = "",
    val intro: String? = null,
    val numEpisodes: Int? = 0,
    val serializeState: Int? = 0,
    val url: String,
    val useAuth:Int? = 0,
    val watchHistory: WatchHistory? = null,
    val lines: MutableList<Line>? = null,
    val subCategoryName:String? = null
): MultiItemEntity {
    override val itemType: Int
        get() = if(chargingCoin == 0) 1 else 2
}

@JsonClass(generateAdapter = true)
data class Line(
    val id:Int,
    val index:Int,
    val defaultDomain:String?,
    val name:String?,
    val updatedAt:Int,
    val createdAt:Int
)

@JsonClass(generateAdapter = true)
data class WatchHistory (
    val resourceType: Int = 1,
    val resourceId: Long = 0,
    val index: Int = 0,
    val userId: Long = 0,
    val createTime: Long = 0,
    val position: Double = 0.0,
    val name: String = "",
    val horizontal: String = "",
    val vertical: String = ""
)