package com.at.video.player.http

import com.at.video.player.entity.*
import com.video.module_widget.entity.AdvertisingBean
import com.video.module_widget.entity.PageListBean
import retrofit2.http.*

/**
 * @Create_time: 2022/5/30 18:45
 * @Description:
 */

interface ApiService {

    // 获取视频信息
    @GET("v1/cms/video_details")
    suspend fun getVideoBean(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): VideoDetailBean

    @GET("v1/cms/video_role")
    suspend fun getActorByVideo(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): ActorBean

    @GET("v1/cms/actor_details")
    suspend fun getStarDetail(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): StarDetailBean

    @GET("v1/cms/actor_with_video")
    suspend fun getStartWork(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): StarWorks

    // 广告列表
    @GET("v1/cms/advertising")
    suspend fun getAdvertisingList(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): PageListBean<AdvertisingBean>

    // 获取视频列表
    @GET("v1/cms/video")
    suspend fun getFilmList(@QueryMap map: @JvmSuppressWildcards Map<String, Any>): VideoList
}
