/*
 * Copyright (C) 2015-2016 Sébastiaan (github.com/se-bastiaan)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.at.video.player.libtorrent;

import com.frostwire.jlibtorrent.PeerInfo;

import java.util.List;

public class StreamStatus {
    public final float progress;
    public final int bufferProgress;
    public final int seeds;
    public final float downloadSpeed;

    public final float uploadSpeed;
    public List<PeerInfo> peerInfos;
    public final String infohash;


    protected StreamStatus(float progress, int bufferProgress, int seeds, int downloadSpeed, List<PeerInfo> peerInfos, int uploadSpeed, String infohash) {
        this.progress = progress;
        this.bufferProgress = bufferProgress;
        this.seeds = seeds;
        this.downloadSpeed = downloadSpeed;
        this.peerInfos = peerInfos;
        this.uploadSpeed = uploadSpeed;
        this.infohash = infohash;
    }

    @Override
    public String toString() {
        return "StreamStatus{" +
                "progress=" + progress +
                ", bufferProgress=" + bufferProgress +
                ", seeds=" + seeds +
                ", downloadSpeed=" + downloadSpeed +
                ", uploadSpeed=" + uploadSpeed +
                ", peerInfos=" + peerInfos +
                ", infohash='" + infohash + '\'' +
                '}';
    }
}