package com.at.video.player.libtorrent.bean;


import android.util.Log;

import com.frostwire.jlibtorrent.TorrentHandle;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;

public class AppendToFile {

    public static int posIndex = 0;

    /**
     * 添加头数据
     *
     * @param inputFile
     * @param th
     * @param bufSize
     * @param HeadNum
     * @return
     */
    //读取系数
    public static boolean addHeadTorrentData(File inputFile, TorrentHandle th, int bufSize, int HeadNum) {
        FileInputStream inputStream = null;
        int index = 0;
        boolean isSuccess = false;
        try {
            inputStream = new FileInputStream(inputFile);
            byte[] data = new byte[bufSize];
            if (th != null) {
                Log.i("TAG", "==>addHeadTorrentData: 开始添加数据");
                while ((inputStream.read(data, 0, bufSize)) != -1) {
                    if (th.isValid()) {
                        try {
                            th.addPiece(index, data);
                            index++;
                        } catch (Exception e) {
                            Log.e("TAG", "==>addHeadTorrentData: " + e);
                        }
                    }
                }
                isSuccess = true;
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        //第一次进入未起播
        for (int i = 0; i < HeadNum; i++) {
            if (th.isValid() && !th.havePiece(i)) {
                //没加成功，再试一次
                isSuccess = fillInPieceBlock(inputFile, th, bufSize, i);
                Log.i("TAG", "==>$$$addHeadTorrentData: 重新添加是否成功" + isSuccess + "\t" + i);
                if (!isSuccess) {//再次尝试也不行情况
                    break;
                }
            }
        }
        Log.i("TAG", "==>$$$addHeadTorrentData: 结束" + System.currentTimeMillis() + "succ==" + isSuccess);
        return isSuccess;
    }

    /**
     * 指定某一块重新填充是否成功
     *
     * @param inputFile
     * @param th
     * @param bufSize
     * @param currentIndex
     * @return
     */
    public static boolean fillInPieceBlock(File inputFile, TorrentHandle th, int bufSize, int currentIndex) {
        FileInputStream inputStream = null;
        try {
            inputStream = new FileInputStream(inputFile);
            byte[] data = new byte[(int) inputFile.length()];
            if (th != null) {
                inputStream.read(data);
                if (th.isValid()) {
                    th.addPiece(currentIndex, data);
                }
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception e) {
            Log.e("TAG", "fillInPieceBlock: " + e.toString());
        } finally {
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

        if (th == null || !th.isValid()) {
            return false;
        }
        return th.havePiece(currentIndex);
    }


    /**
     * 添加需要块信息
     *
     * @param inputFile
     * @param th
     * @param bufSize
     * @param index
     * @return
     */
    private static int resetAddDataNum = 0;

    // public static void addTorrentData(File inputFile, TorrentHandle th, int bufSize, int index, int maxPiece, SuccessListener listener) {
    //
    //     TorrentEngine.getInstance().getTorrentSession().addListener(new TorrentAlertListener("play") {
    //         @Override
    //         public void torrentChecked(AddTorrentAlert alert) {
    //             boolean addTorrentData = addTorrentData(inputFile, th, bufSize, index, maxPiece);
    //             listener.listener(addTorrentData);
    //         }
    //     });
    // }

    public static boolean addTorrentData(File inputFile, TorrentHandle th, int bufSize, int index, int maxPiece) {
        FileInputStream inputStream = null;
        try {
            inputStream = new FileInputStream(inputFile);
            byte[] data = new byte[bufSize];
            if (th != null) {
                while ((inputStream.read(data, 0, bufSize)) != -1) {
                    if (th.isValid()) {
                        try {
                            th.addPiece(index, data);
                            index++;
                        } catch (Exception e) {
                            Log.e("TAG", "==>addHeadTorrentData: " + e);
                        }
                    }
                }
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        //滑动播放
        boolean allSuccess = true;
        for (int i = index; i < maxPiece; i++) {//判断是否全部下载完成
            if (th.isValid() && !th.havePiece(i)) {
                allSuccess = false;
            }
        }
        if (!allSuccess && resetAddDataNum < 2) {//最多执行两次
            allSuccess = addTorrentData(inputFile, th, bufSize, index, maxPiece);
            resetAddDataNum++;
        }
        resetAddDataNum = 0;
        return allSuccess;
    }

    /**
     * @param inputFile
     * @param outfile
     */
    public static void appendFileContent(File inputFile, File outfile) {
        appendFileContent(posIndex, inputFile, outfile);
    }

    /**
     * 追加指定文件的内容到指定位置
     *
     * @param inputFile
     * @param outfile
     * @param pos       0从开始写入文件 -1 从尾部开始写入文件 其他 从指定位置写入文件
     */
    public static void appendFileContent(int pos, File inputFile, File outfile) {
        FileInputStream inputStream = null;
        RandomAccessFile randomFile = null;
        try {
            // 打开一个随机访问文件流，按读写方式
            randomFile = new RandomAccessFile(outfile, "rw");
            // 文件长度，字节数
            long fileLength = 0;
            if (pos == -1) {
                fileLength = randomFile.length();
            } else {
                fileLength = pos;
            }

            //将写文件指针移到文件尾。
            randomFile.seek(fileLength);

            inputStream = new FileInputStream(inputFile);

            int sBufferSize = 8192;//8k
            byte[] data = new byte[sBufferSize];
            int len;
            while ((len = inputStream.read(data, 0, sBufferSize)) != -1) {
                randomFile.write(data, 0, len);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (inputStream != null) {
                    inputStream.close();
                }
                if (randomFile != null) {
                    randomFile.close();
                }

            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

}
