package com.at.video.player.libtorrent.bean;

import android.text.TextUtils;

import java.io.Serializable;
import java.util.Arrays;

public class CacheEntity implements Serializable {
    private int id;
    /**
     * 视频名称
     */
    private String VideoName;

    /**
     * 加速节点
     */
    private String xpe;

    /**
     * 源下载节点
     */
    private String xpm;

    /**
     * 视频缩略图下载地址
     */
    private String VideoThumURL;
    /**
     * 视频下载地址
     */
    private String VideoURL;
    /**
     * 视频标记tag
     */
    private String VideoTag;
    /**
     * 视频下载路径
     */
    private String VideoPath;

    /**
     * 下载状态
     */
    private int state = -1;
    /**
     * 数据总大小
     */
    private long totalSize;
    /**
     * 已经下载大小
     */
    private long proSize;
    /**
     * 最近下载速度
     */
    private long downSpeed;

    /**
     * 磁力链解析成功的code
     */
    private byte[] bdcode;

    /**
     * 视频是否已经准备好
     */
    private boolean isReady;

    private String videoid;

    //原磁力链接
    private String magnet;

    /**
     * 缓存名字
     */
    private String cacheName;

    public String getCacheName() {
        return cacheName;
    }

    public void setCacheName(String cacheName) {
        this.cacheName = cacheName;
    }

    public String getMagnet() {
        return magnet;
    }

    public void setMagnet(String magnet) {
        this.magnet = magnet;
    }

    public String getXpe() {
        return xpe;
    }

    public void setXpe(String xpe) {
        this.xpe = xpe;
    }

    public String getXpm() {
        return xpm;
    }

    public void setXpm(String xpm) {
        this.xpm = xpm;
    }

    public String getVideoid() {
        return videoid;
    }

    public void setVideoid(String videoid) {
        this.videoid = videoid;
    }

    public boolean isReady() {
        return isReady;
    }

    public void setReady(boolean ready) {
        isReady = ready;
    }

    public String getVideoName() {
        return VideoName;
    }

    public void setVideoName(String videoName) {
        VideoName = videoName;
    }

    public String getVideoThumURL() {
        return VideoThumURL;
    }

    public void setVideoThumURL(String videoThumURL) {
        VideoThumURL = videoThumURL;
    }

    public String getVideoURL() {
        return TextUtils.isEmpty(VideoURL) ? "" : VideoURL;
    }

    public void setVideoURL(String videoURL) {
        VideoURL = videoURL;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getVideoPath() {
        if (TextUtils.isEmpty(VideoPath)) {
            VideoPath = "";
        }
        return VideoPath;
    }

    public void setVideoPath(String videoPath) {
        VideoPath = videoPath;
    }

    public String getVideoTag() {
        return VideoTag;
    }

    public void setVideoTag(String videoTag) {
        VideoTag = videoTag;
    }

    public int getState() {
        return state;
    }

    public void setState(int state) {
        this.state = state;
    }

    public long getTotalSize() {
        return totalSize;
    }

    public void setTotalSize(long totalSize) {
        this.totalSize = totalSize;
    }

    public long getProSize() {
        return proSize;
    }

    public void setProSize(long proSize) {
        this.proSize = proSize;
    }

    public long getDownSpeed() {
        return downSpeed;
    }

    public void setDownSpeed(long downSpeed) {
        this.downSpeed = downSpeed;
    }

    public byte[] getBdcode() {
        return bdcode;
    }

    public void setBdcode(byte[] bdcode) {
        this.bdcode = bdcode;
    }

    @Override
    public String toString() {
        return "CacheEntity{" +
                "id=" + id +
                ", VideoName='" + VideoName + '\'' +
                ", xpe='" + xpe + '\'' +
                ", xpm='" + xpm + '\'' +
                ", VideoThumURL='" + VideoThumURL + '\'' +
                ", VideoURL='" + VideoURL + '\'' +
                ", VideoTag='" + VideoTag + '\'' +
                ", VideoPath='" + VideoPath + '\'' +
                ", state=" + state +
                ", totalSize=" + totalSize +
                ", proSize=" + proSize +
                ", downSpeed=" + downSpeed +
                ", bdcode=" + Arrays.toString(bdcode) +
                ", isReady=" + isReady +
                ", videoid='" + videoid + '\'' +
                ", magnet='" + magnet + '\'' +
                '}';
    }
}
