package com.at.video.player.ui.detail.binder

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.at.common.global.Constants
import com.at.video.player.R
import com.at.video.player.entity.StarVideoInfo
import com.at.video.player.entity.StarWorkCategoryInfo
import com.at.video.player.entity.VideoInfo
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.router.api.launcher.Router
import com.melancholy.widget.decoration.DefaultDecoration

/**
 * @Create_time: 2022/5/18 13:57
 * @Description:
 */

class TelevisionWorksBinderView(private val pool: RecyclerView.RecycledViewPool): BaseItemBinder<
        StarWorkCategoryInfo, BaseViewHolder>(),  OnItemClickListener {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        val holder = BaseViewHolder(LayoutInflater.from(parent.context).inflate(
            R.layout.player_television_works_view, parent, false))
        val recyclerView: RecyclerView = holder.getView(R.id.recycler_view)
        recyclerView.setHasFixedSize(true)
        recyclerView.itemAnimator = null
        recyclerView.setRecycledViewPool(pool)
        val adapter = TelevisionWorksAdapter()
        adapter.setOnItemClickListener(this)
        recyclerView.adapter = adapter
        val padding: Int = parent.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_16)
        val cPadding: Int = parent.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_8)
        recyclerView.addItemDecoration(DefaultDecoration.create(padding, 0, padding,
            0, cPadding, 0))
        return holder
    }

    override fun convert(holder: BaseViewHolder, data: StarWorkCategoryInfo) {
        holder.setText(R.id.tv_title,data.category.name)
        (holder.getView<RecyclerView>(R.id.recycler_view).adapter as TelevisionWorksAdapter)
            .setNewInstance(data.video_list?.toMutableList())
    }

    override fun onItemClick(adapter: BaseQuickAdapter<*, *>, view: View, position: Int) {
        val data: StarVideoInfo = adapter.getItem(position) as StarVideoInfo
        Router.getInstance().build("/player/PlayerActivity")
            .withString(Constants.KEY_DATA, data.id!!).navigation()
    }
}