package com.at.video.player.ui.player

import android.view.View
import com.at.video.player.R
import com.at.video.player.entity.Line
import com.at.video.player.entity.LineBean
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.widget.ShapeTextViewExt

/**
 * @Create_time: 2022/5/13 13:47
 * @Description:
 */

class TagAdapter: BaseQuickAdapter<LineBean, BaseViewHolder>(R.layout.player_item_tag) {
    private var mSelectIndex: Int = 0

    override fun createBaseViewHolder(view: View): BaseViewHolder {
        val params = view.layoutParams
        params.width = view.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_100)
        view.layoutParams = params
        return super.createBaseViewHolder(view)
    }

    override fun convert(holder: BaseViewHolder, item: LineBean) {
        holder.setText(R.id.tv_text, if(item.name.isNullOrEmpty()) "线路${item.number}" else item.name)
        changeTxtStyle(holder.getView(R.id.tv_text),mSelectIndex == holder.bindingAdapterPosition)
    }

    private fun changeTxtStyle(text:ShapeTextViewExt,isSelected:Boolean){
        text.apply {
            val textColor = if(isSelected) StyleUtils.primaryColor else context.resources.getColor(R.color.color_FF333333)
            setTextColor(textColor)
            val borderWidth = if(isSelected) 2 else 1
            setBorderWidth(borderWidth)
            val borderColor = if(isSelected) StyleUtils.primaryColor else context.resources.getColor(R.color.color_FFAEB3B9)
            setBorderColor(borderColor)
            reBuilder()
        }
    }


    override fun convert(holder: BaseViewHolder, item: LineBean, payloads: List<Any>) {
        changeTxtStyle(holder.getView(R.id.tv_text),mSelectIndex == holder.bindingAdapterPosition)
    }

    fun setIndex(index: Int) {
        val prevIndex: Int = mSelectIndex
        mSelectIndex = index
        notifyItemChanged(prevIndex, "notify")
        notifyItemChanged(mSelectIndex,"notify")
    }
}