package com.at.video.player.ui.player.binder

import android.graphics.Color
import android.graphics.Typeface
import android.text.Spannable
import android.text.SpannableStringBuilder
import android.text.style.ForegroundColorSpan
import android.text.style.StyleSpan
import android.view.LayoutInflater
import android.view.ViewGroup
import com.at.video.player.R
import com.at.video.player.databinding.PlayerSynopsisViewBinding
import com.at.video.player.entity.Extra
import com.at.video.player.entity.RoleBean
import com.at.video.player.entity.VideoBean
import com.chad.library.adapter.base.binder.QuickViewBindingItemBinder
import com.video.module_widget.hot2String
import com.video.module_widget.strToInt
import com.video.module_widget.utils.CommonStringUtils


/**
 * @Create_time: 2022/5/13 10:20
 * @Description: 简介
 */

class SynopsisBinder :
    QuickViewBindingItemBinder<SynopsisBinder.SynopsisData, PlayerSynopsisViewBinding>() {

    override fun onCreateViewBinding(
        layoutInflater: LayoutInflater, parent: ViewGroup, viewType: Int
    ): PlayerSynopsisViewBinding {
        return PlayerSynopsisViewBinding.inflate(layoutInflater, parent, false)
    }

    override fun convert(holder: BinderVBHolder<PlayerSynopsisViewBinding>, data: SynopsisData) {
        val scoreTxt = if (data.data.score?.toFloat() == 0f) "" else "${data.data.score}分"
        val area =
            if (data.data.area != null && data.data.area.isNotEmpty()) "${data.data.area}" else ""
//        val categoryName = if(data.data.categoryName!=null&&data.data.categoryName.isNotEmpty()) "${data.data.categoryName}" else ""

        val subCategoryName =
            if (!data.data.subcateg_name.isNullOrEmpty()) "${data.data.subcateg_name}" else ""
        val heat = "${data.data.popularity?.strToInt()?.plus(1)?.hot2String()}"
//        val res = "$heat**$scoreTxt**$area**$categoryName**$subCategoryName"
//        val labelArr = res.split("**").filter { it.isNotEmpty() }
//        val showTxt = labelArr.joinToString(" / ")
        holder.setText(R.id.tv_title, data.data.name).setText(
            R.id.tv_publish_time, ""
        ).setText(
            R.id.tv_like,
            if (data.extra != null) data.extra.pop_like?.strToInt()?.hot2String() else "0"
        ).setText(
            R.id.tv_collect,
            if (data.extra != null) data.extra.pop_collection?.strToInt()?.hot2String() else "0"
        ).setText(R.id.tv_heat, heat).setGone(R.id.tv_heat, heat.isEmpty())

        dealPubilshTime(data, subCategoryName, scoreTxt, holder)
    }

    private fun dealPubilshTime(
        data: SynopsisData,
        subCategoryName: String,
        scoreTxt: String,
        holder: BinderVBHolder<PlayerSynopsisViewBinding>
    ) {
        // 处理时间展示
        val desc = CommonStringUtils.splicingStrings(
            data.data.release_date, data.data.categ_name, subCategoryName
        )
        val builder = SpannableStringBuilder()
        var startLength = 0
        val empty = " "
        if (!desc.isNullOrEmpty()) {
            builder.append(desc)
            startLength = desc.length
        }
        try {
            if (!scoreTxt.isNullOrEmpty()) {
                builder.append(empty)
                startLength += empty.length
                builder.append(scoreTxt)
                val colorSpan = ForegroundColorSpan(Color.parseColor("#FFB027"))
                builder.setSpan(
                    colorSpan,
                    startLength,
                    startLength + scoreTxt.length,
                    Spannable.SPAN_EXCLUSIVE_INCLUSIVE
                )
                val bodySpan = StyleSpan(Typeface.BOLD)
                builder.setSpan(
                    bodySpan,
                    startLength,
                    startLength + scoreTxt.length,
                    Spannable.SPAN_EXCLUSIVE_INCLUSIVE
                )
            }

        } catch (e: Exception) {

        }
        if (builder.isNotEmpty()) {
            holder.setText(R.id.tv_publish_time, builder).setGone(R.id.tv_publish_time, false)
        } else {
            holder.setGone(R.id.tv_publish_time, true)
        }

    }

    override fun convert(
        holder: BinderVBHolder<PlayerSynopsisViewBinding>, data: SynopsisData, payloads: List<Any>
    ) {
        super.convert(holder, data, payloads)
    }

    data class SynopsisData(val data: VideoBean, val actorList: List<RoleBean>, val extra: Extra?)
}