package com.at.video.player.ui.player.binder

import android.graphics.Color
import android.util.TypedValue
import android.view.ViewGroup
import android.view.ViewGroup.MarginLayoutParams
import android.view.ViewGroup.MarginLayoutParams.MATCH_PARENT
import android.view.ViewGroup.MarginLayoutParams.WRAP_CONTENT
import android.widget.TextView
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.viewholder.BaseViewHolder

/**
 * @Create_time: 2022/5/13 14:56
 * @Description:
 */

class TitleBinder: BaseItemBinder<String, BaseViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        val text = TextView(parent.context)
        val params = MarginLayoutParams(MATCH_PARENT, WRAP_CONTENT)
        text.layoutParams = params
        text.setTextSize(TypedValue.COMPLEX_UNIT_PX, parent.context.resources.getDimensionPixelSize(
            com.at.common.R.dimen.sp_14).toFloat())
        text.setTextColor(Color.BLACK)
        val padding: Int = parent.context.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_16)
        val bottomPadding: Int = parent.context.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_8)
        text.setPadding(padding, padding, text.paddingRight, bottomPadding)
        return BaseViewHolder(text)
    }

    override fun convert(holder: BaseViewHolder, data: String) {
        (holder.itemView as TextView).text = data
    }
}