package com.at.video.player.ui.player.synopsis

import android.annotation.SuppressLint
import android.content.Context
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.at.video.player.R
import com.at.video.player.ui.player.LevelAdapter
import com.at.video.player.ui.player.binder.LevelBinder
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.lxj.xpopup.core.BottomPopupView
import com.melancholy.widget.decoration.DefaultDecoration
import com.video.module_widget.entity.Content

/**
 * @Create_time: 2022/5/13 15:54
 * @Description:
 */

class EpisodePopup(context: Context, val data: LevelBinder.LevelData, val type:Int = 1,private val mOnLevelListener: LevelBinder.OnLevelListener):
    BottomPopupView(context), View.OnClickListener, OnItemClickListener {

    override fun getImplLayoutId(): Int = R.layout.player_popup_episode
    var adapter = LevelAdapter(isMore = true)
    @SuppressLint("SetTextI18n")
    override fun onCreate() {
        super.onCreate()
        findViewById<View>(R.id.iv_close).setOnClickListener(this)
        val recyclerView: RecyclerView = findViewById(R.id.rv_data)
            recyclerView.layoutManager = GridLayoutManager(context,6)
            recyclerView.adapter = adapter
            adapter.setNewInstance(data.list.toMutableList())
        val padding =context.resources.getDimensionPixelSize(com.at.common.R.dimen.dp_8)
            recyclerView.addItemDecoration(DefaultDecoration.create(padding))
        adapter.setIndex(data.index)
        adapter.setOnItemClickListener(this)
    }
    fun setStyle(mStyle: Content?){
        adapter.setStyle(mStyle)
    }

    fun setIndex(index:Int){
        adapter.setIndex(index)
    }
    override fun onClick(p0: View?) {
        dismiss()
    }

    override fun onItemClick(adapter: BaseQuickAdapter<*, *>, view: View, position: Int) {
        mOnLevelListener.onLevel(data, position)
        dismiss()
    }
}