package com.at.video.player.ui.player.synopsis

import com.at.video.player.R
import com.at.video.player.entity.RoleBean
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.widget.DiversityImageView
import com.video.module_widget.imageUrl
import com.video.module_widget.utils.GlideImageConfig
import com.video.module_widget.utils.loadByGlide
import java.lang.ref.WeakReference

/**
 * @Create_time: 2022/5/18 16:19
 * @Description:
 */

class StarAdapter : BaseQuickAdapter<RoleBean, BaseViewHolder>(R.layout.player_item_star) {

    override fun convert(holder: BaseViewHolder, data: RoleBean) {
        holder.getView<DiversityImageView>(R.id.div_img)
            .loadByGlide(
                GlideImageConfig(
                    data.cover.imageUrl(),
                    placeholderId = com.video.module_widget.R.drawable.common_ic_image_altas_default,
                    errorId = com.video.module_widget.R.drawable.common_ic_image_altas_default
                ),
                WeakReference(context)
            )

        val label = if(!data.name.isNullOrEmpty()) "饰 ${data.name}" else ""
        holder.setText(R.id.tv_name, "${data.person_name} $label")
    }
}