package com.at.video.player.ui.work.television.binder

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import android.widget.ImageView
import com.at.common.ImageConfig
import com.at.common.load
import com.at.video.player.R
import com.at.video.player.entity.StarVideoInfo
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.widget.DiversityImageView
import com.video.module_widget.imageUrl
import com.video.module_widget.utils.StyleUtils
import com.video.module_widget.widget.ShapeMaterialButtonExt

/**
 * @Create_time: 2022/5/13 15:04
 * @Description:
 */

class ItemPayBinder(val type: Int = 1) : BaseItemBinder<ItemPayBinder.Pay, BaseViewHolder>() {

    private fun getRootParamsByStyleType(): FrameLayout.LayoutParams {
        val params = FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT, StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_190))

        when (type) {
            1 -> {
                params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_266)
            }
            2 -> {
                params.height = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_190)
            }
            else -> {
            }
        }
        return params
    }

    private fun getImageParamsByType() = when (type) {
        1 -> {
            com.at.common.R.dimen.dp_221
        }
        2 -> {
            com.at.common.R.dimen.dp_141
        }
        else -> {
            com.at.common.R.dimen.dp_141
        }
    }

    private fun changeTagStyle(tagView: ShapeMaterialButtonExt) {
        val params = tagView.layoutParams as FrameLayout.LayoutParams
        when (StyleUtils.tagStyle) {
            2 -> {
                tagView.setShapeRadius(com.at.common.R.dimen.dp_10)
                params.rightMargin = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_4)
                params.topMargin = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_4)
                tagView.reBuilder()
            }
            3 -> {
                tagView.setShapeRadius(com.at.common.R.dimen.dp_10, com.at.common.R.dimen.dp_10)
                params.topMargin = StyleUtils.getDpByDimen(com.at.common.R.dimen.dp_8)
                tagView.reBuilder()
            }
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        val view: View = LayoutInflater.from(parent.context).inflate(
            R.layout.player_item_television_pay,
            parent,
            false
        )
        return BaseViewHolder(view)
    }

    override fun convert(holder: BaseViewHolder, item: Pay) {
        val root = holder.getView<FrameLayout>(R.id.fl_root)
        root.layoutParams = getRootParamsByStyleType()
        val image = holder.getView<DiversityImageView>(R.id.div_icon)
        val params = image.layoutParams
        params.height = StyleUtils.getDpByDimen(getImageParamsByType())

        holder.getView<ImageView>(R.id.div_icon)
            .load(
                ImageConfig(
                    item.info.cover_vertical.imageUrl(),
                    placeholderId = com.video.module_widget.R.drawable.common_ic_image_video_default,
                    errorId = com.video.module_widget.R.drawable.common_ic_image_video_default
                )
            )
        val numStr = if (item.info.publish_status?.toInt() == 1) "已完结" else "全${item.info.episode}集"
        holder.setText(R.id.tv_name, item.info.name)
            .setText(R.id.tv_numEpisodes, numStr)
        holder.setText(R.id.smb_glod, item.info.price)
        changeTagStyle(holder.getView(R.id.smb_glod))
    }

    data class Pay(val info: StarVideoInfo)
}
