package com.at.video.service.entity

import android.os.Build
import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.JsonClass
import java.io.Serializable

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/6/16 上午11:13
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/6/16 上午11:13
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
@JsonClass(generateAdapter = true)
data class OrderData (
    val id:Int,
    val work_id: String?,
    val title:String?,
    val visitor_state:Int,
    val created_at:String?,
    val content:String?,
    val kefu_state:Int,
    val kefu_id:String?,
    val visitor_avatar:String?,
    val type:Int,
    val appendix:List<FileInfo>?
): Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readInt(),
        parcel.readString(),
        parcel.readString(),
        parcel.readInt(),
        parcel.readString(),
        parcel.readString(),
        parcel.readInt(),
        parcel.readString(),
        parcel.readString(),
        parcel.readInt(),
        parcel.createTypedArrayList(FileInfo)
    ) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(id)
        parcel.writeString(work_id)
        parcel.writeString(title)
        parcel.writeInt(visitor_state)
        parcel.writeString(created_at)
        parcel.writeString(content)
        parcel.writeInt(kefu_state)
        parcel.writeString(kefu_id)
        parcel.writeString(visitor_avatar)
        parcel.writeInt(type)
        parcel.writeTypedList(appendix)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<OrderData> {
        override fun createFromParcel(parcel: Parcel): OrderData {
            return OrderData(parcel)
        }

        override fun newArray(size: Int): Array<OrderData?> {
            return arrayOfNulls(size)
        }
    }
}