package com.at.video.service.entity

import android.net.Uri
import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.JsonClass
import java.io.Serializable

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/6/17 下午1:19
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/6/17 下午1:19
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
@JsonClass(generateAdapter = true)
data class OrderDetailMsgInfo(
    val content:String?,
    val content_type:String?,
    val created_at:String?,
    val msg_type:Int,
    val visitor_avatar:String?,
    val appendix:List<FileInfo>?
)
@JsonClass(generateAdapter = true)
data class FileInfo(
    val path:String?,
    val name:String?
):Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readString(),
        parcel.readString()
    ) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(path)
        parcel.writeString(name)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<FileInfo> {
        override fun createFromParcel(parcel: Parcel): FileInfo {
            return FileInfo(parcel)
        }

        override fun newArray(size: Int): Array<FileInfo?> {
            return arrayOfNulls(size)
        }
    }
}