package com.at.video.service.http.body

import com.at.video.service.http.listener.ProgressRequestListener
import okhttp3.MediaType
import okhttp3.RequestBody
import okio.*
import kotlin.math.sin

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/6/22 下午3:09
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/6/22 下午3:09
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
class ProgressRequestBody(private val requestBody: RequestBody, val progressListener:ProgressRequestListener): RequestBody() {

   private var bufferSink:BufferedSink? = null

    override fun contentType(): MediaType? = requestBody.contentType()

    override fun contentLength(): Long =  requestBody.contentLength()

    override fun writeTo(sink: BufferedSink) {
        if(bufferSink == null){
            bufferSink = sink(sink).buffer()
        }
        requestBody.writeTo(bufferSink!!)
        bufferSink!!.flush()
    }

    private fun sink(sink:Sink):Sink{
        return object :ForwardingSink(sink){
            var bytesWritten = 0L
            var contentLength = 0L
            override fun write(source: Buffer, byteCount: Long) {
                super.write(source, byteCount)
                if(contentLength == 0L){
                    contentLength = contentLength()
                }
                bytesWritten +=byteCount
                if(progressListener!=null){
                    progressListener.onRequestProgress(bytesWritten,contentLength,bytesWritten ==contentLength)
                }
            }
        }
    }
}