package com.at.video.service.http.body

import com.at.video.service.http.listener.ProgressRequestListener
import com.at.video.service.http.listener.ProgressResponseListener
import okhttp3.MediaType
import okhttp3.RequestBody
import okhttp3.ResponseBody
import okio.*
import kotlin.math.sin

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/6/22 下午3:09
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/6/22 下午3:09
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
class ProgressResponseBody(private val responseBody: ResponseBody, val progressListener:ProgressResponseListener): ResponseBody() {

   private var bufferedSource:BufferedSource? = null

    override fun contentType(): MediaType? = responseBody.contentType()

    override fun contentLength(): Long =  responseBody.contentLength()
    override fun source(): BufferedSource {
        if(bufferedSource == null){
            bufferedSource = source(responseBody.source()).buffer()
        }
        return bufferedSource!!
    }

    private fun source(source: Source): ForwardingSource {
        return object :ForwardingSource(source){
            var totalBytesRead = 0L
            override fun read(sink: Buffer, byteCount: Long): Long {
                var bytesRead = super.read(sink, byteCount)
                totalBytesRead +=if(bytesRead!=-1L)bytesRead else 0L
                if(progressListener!=null){
                    progressListener.onResponseProgress(totalBytesRead,responseBody.contentLength(),bytesRead == -1L)
                }
                return  bytesRead
            }
        }
    }

}