package com.at.video.service.ui.dialog

import android.os.Bundle
import android.view.*
import androidx.fragment.app.FragmentManager
import com.at.common.binding.BaseBindingDialogFragment
import com.at.video.service.R
import com.at.video.service.databinding.ServiceDialogBottonHeadBinding

/**
 * @description:
 * @author:  stone
 * @email:
 * @date :   2022/5/5 上午9:47
 */
class BottomHeadDialog : BaseBindingDialogFragment<ServiceDialogBottonHeadBinding>(),
    View.OnClickListener {
    private var mCallback: ((Int) -> Unit)? = null

    companion object {
        @JvmStatic
        @JvmOverloads
        fun showDialog(ft: FragmentManager, callback: (Int) -> Unit, tag: String? = null) {
            BottomHeadDialog()
                .setCallback(callback)
                .show(ft, tag)
        }
    }

    override fun getCustomTheme(): Int = R.style.DialogTheme

    override fun getWidth(): Int = WindowManager.LayoutParams.MATCH_PARENT

    override fun getGravity(): Int = Gravity.BOTTOM

    override fun getCancelable(): Boolean = false

    override fun createViewBinding(inflater: LayoutInflater, container: ViewGroup?,
                                   savedInstanceState: Bundle?): ServiceDialogBottonHeadBinding {
        return ServiceDialogBottonHeadBinding.inflate(inflater, container, false)
    }

    override fun initialize(view: View, savedInstanceState: Bundle?) {
        requireBinding().apply {
            tvAlbum.setOnClickListener(this@BottomHeadDialog)
            tvTakingPictures.setOnClickListener(this@BottomHeadDialog)
            tvCancel.setOnClickListener(this@BottomHeadDialog)
        }
    }

    override fun loadData() {

    }

    fun setCallback(callback: (Int) -> Unit): BottomHeadDialog {
        mCallback = callback
        return this
    }

    override fun onClick(view: View) {
        when (view.id) {
            R.id.tv_album -> {
                mCallback?.invoke(0)
            }
            R.id.tv_taking_pictures -> {
                mCallback?.invoke(1)
            }
        }
        dismiss()
    }
}