package com.at.video.service.ui.service.conversation

import android.text.Html
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.at.common.ImageConfig
import com.at.common.global.Constants
import com.at.common.load
import com.at.video.service.R
import com.at.video.service.entity.Message
import com.at.video.service.ui.service.emoji.EmojiConversionUtils
import com.chad.library.adapter.base.BaseMultiItemQuickAdapter
import com.chad.library.adapter.base.entity.MultiItemEntity
import com.chad.library.adapter.base.viewholder.BaseViewHolder

/**
 * @Create_time: 2022/5/9 20:20
 * @Description:
 */

data class ChartData(
    val message: Message,
    override val itemType: Int = message.msg_type - 1
): MultiItemEntity

class ServiceAdapter: BaseMultiItemQuickAdapter<ChartData, BaseViewHolder>() {

    init {
        addItemType(0, R.layout.service_item_service_left)
        addItemType(1, R.layout.service_item_service_right)
    }

    override fun convert(holder: BaseViewHolder, item: ChartData) {

        val defaultAvatar = if(item.message.msg_type == 1)R.drawable.service_ic_default_header else R.drawable.service_ic_user_default_header
         holder.getView<ImageView>(R.id.div_header).load(ImageConfig(Constants.SERVICE_URL+item.message.avatar, placeholderId = defaultAvatar, errorId = defaultAvatar))
        if(item.message.content_type.isNullOrEmpty()){
            holder.getView<ImageView>(R.id.div_image).visibility = View.GONE
            holder.setVisible(R.id.stv_message,true)
            val content = item.message.content!!.replace("<p>","").replace("</p>","")
            val expressionString =
                EmojiConversionUtils.INSTANCE.getExpressionString(context, content)
            holder.setText(R.id.stv_message,Html.fromHtml(expressionString.toString()))
        }else{
            holder.getView<TextView>(R.id.stv_message).visibility = View.GONE
            holder.setVisible(R.id.div_image,true)
            holder.getView<ImageView>(R.id.div_image).load(ImageConfig(item.message.content_type))
        }
    }

//    override fun getItemBackColor(): Int {
//        return Color.TRANSPARENT
//    }
//
//    override fun getItemHeight(): Int {
//        return AppInstance.getApplication().resources.getDimensionPixelOffset(com.at.common.R.dimen.dp_24)
//    }
//
//    override fun getText(position: Int): String? {
//        return "2022-04-24 16:34 $position"
//    }
//
//    override fun getTextColor(): Int {
//        return ContextCompat.getColor(AppInstance.getApplication(), R.color.color_FFB4B8BF)
//    }
//
//    override fun horizontalGravity(): Int {
//        return GravityLetter.CENTER
//    }
//
//    override fun getTextPaddingLeft(): Int {
//        return 0
//    }
//
//    override fun getTextSize(): Int {
//        return AppInstance.getApplication().resources.getDimensionPixelOffset(com.at.common.R.dimen.sp_12)
//    }
//
//    override fun isFoldAnimation(): Boolean {
//        return true
//    }
//
//    override fun isSuspension(): Boolean {
//        return false
//    }
//
//    override fun verticalGravity(): Int {
//        return GravityLetter.TOP
//    }
//
//    override fun verticalPadding(): Int {
//        return GravityLetter.CENTER
//    }
}