package com.at.video.service.ui.service.emoji

import android.view.View
import android.view.ViewGroup
import android.view.ViewGroup.LayoutParams.MATCH_PARENT
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.chad.library.adapter.base.viewholder.BaseViewHolder

/**
 * @Create_time: 2022/5/7 17:47
 * @Description:
 */

class EmojiAdapter constructor(private val pool: RecyclerView.RecycledViewPool):
    BaseQuickAdapter<List<EmojiEntry>, BaseViewHolder>(0), OnItemClickListener {
    private var mOnItemClickListener: OnItemClickListener? = null

    fun setItemClickListener(listener: OnItemClickListener) {
        mOnItemClickListener = listener
    }

    override fun onCreateDefViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        val recyclerView = RecyclerView(parent.context)
        recyclerView.layoutManager = GridLayoutManager(parent.context, 7)
        recyclerView.layoutParams = ViewGroup.LayoutParams(MATCH_PARENT, MATCH_PARENT)
        recyclerView.setHasFixedSize(true)
        recyclerView.itemAnimator = null
        recyclerView.setRecycledViewPool(pool)
        val adapter = EmojiItemAdapter()
        adapter.setOnItemClickListener(this)
        recyclerView.adapter = adapter
        return createBaseViewHolder(recyclerView)
    }

    override fun convert(holder: BaseViewHolder, item: List<EmojiEntry>) {
        val adapter: EmojiItemAdapter = (holder.itemView as RecyclerView).adapter as EmojiItemAdapter
        adapter.setNewInstance(item.toMutableList())
    }

    override fun onItemClick(adapter: BaseQuickAdapter<*, *>, view: View, position: Int) {
        mOnItemClickListener?.onItemClick(adapter, view, position)
    }
}