package com.at.video.service.ui.service.emoji

import android.view.ViewGroup
import android.view.ViewGroup.LayoutParams.MATCH_PARENT
import android.widget.ImageView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.at.video.service.R
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder

/**
 * @Create_time: 2022/5/6 20:12
 * @Description:
 */

class EmojiItemAdapter: BaseQuickAdapter<EmojiEntry, BaseViewHolder>(R.layout.service_item_emoji) {

    override fun onCreateDefViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        val imageView = ImageView(parent.context)
        imageView.layoutParams = ViewGroup.LayoutParams(MATCH_PARENT, parent.measuredHeight / 3)
        val padding: Int = parent.context.resources.getDimensionPixelOffset(com.at.common.R.dimen.dp_15)
        imageView.setPadding(padding, padding, padding, padding)
        return createBaseViewHolder(imageView)
    }

    override fun convert(holder: BaseViewHolder, item: EmojiEntry) {
        val imageView: ImageView = holder.itemView as ImageView
        if(item.id == R.drawable.service_ic_emoji_item_delete) {
            imageView.setImageResource(item.id)
        } else if(item.character.isNullOrEmpty()) {
            imageView.setImageDrawable(null)
        } else {
            imageView.setImageResource(item.id)
        }
    }
}