package com.at.video.service.ui.service.order

import android.graphics.drawable.GradientDrawable
import android.widget.TextView
import com.at.video.service.R
import com.at.video.service.entity.OrderData
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.utils.DateUtils
import com.melancholy.widget.shape.view.ShapeTextView
import org.joda.time.DateTime
import java.util.*

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/6/16 上午10:36
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/6/16 上午10:36
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
class OrderItemAdapter: BaseQuickAdapter<OrderData,
        BaseViewHolder>(R.layout.service_order_item) {

    override fun convert(holder: BaseViewHolder, item: OrderData) {
        holder.setText(R.id.tv_title,item.title)
        var statusText = ""
        var textColors = 0
        var bgColor = 0
        try {
            val dateTime = DateTime(item.created_at!!)
            val result = dateTime.toCalendar(Locale.getDefault()).timeInMillis
            val time = DateUtils.format(result,"yyyy-MM-dd HH:mm:ss")
            holder.setText(R.id.tv_date,time)
        }catch (e:Exception){
        }
        when(item.visitor_state){
            1->{
                statusText = "处理中"
                textColors = R.color.color_FF0083FF
                bgColor = R.color.color_FFE6F4FF
            }
            2->{
                statusText = "待反馈"
                textColors = R.color.color_FFED7B2F
                bgColor = R.color.color_FFFEF3E6
            }
            3->{
                statusText = "已结束"
                textColors = R.color.color_FFC5C5C5
                bgColor = R.color.color_FFF5F5F5
            }
            4->{
                statusText = "已撤销"
                textColors = R.color.color_FFC5C5C5
                bgColor = R.color.color_FFF5F5F5
            }
            5 -> {
                statusText = "已失效"
                textColors = R.color.color_FFC5C5C5
                bgColor = R.color.color_FFF5F5F5
            }
            6-> {
                statusText = "未处理"
                textColors = R.color.color_FFE34D59
                bgColor = R.color.color_FFFDECEE
            }

        }
        val status = holder.getView<TextView>(R.id.stv_status)

        status.apply {
            text = statusText
        }
        val bgDrawable = status.background as GradientDrawable
        bgDrawable.setColor(context.resources.getColor(bgColor))
        holder.setTextColor(R.id.stv_status,context.resources.getColor(textColors))

    }


}