package com.at.video.service.ui.service.order.add

import android.graphics.Canvas
import android.graphics.Color
import android.graphics.Rect
import android.graphics.drawable.ColorDrawable
import android.graphics.drawable.Drawable
import android.view.View
import androidx.recyclerview.widget.RecyclerView
import com.melancholy.utils.AppInstance

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/6/17 上午9:54
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/6/17 上午9:54
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */

class DividerLineDecoration : RecyclerView.ItemDecoration() {
    private val mBounds = Rect()
    private var mDivider: Drawable = ColorDrawable(Color.RED)

    private var paddingHorizontal = AppInstance.getApplication().resources
        .getDimensionPixelSize(com.at.common.R.dimen.dp_16)
    private var lineHeight = AppInstance.getApplication().resources
        .getDimensionPixelSize(com.at.common.R.dimen.dp_1)
    override fun getItemOffsets(
        outRect: Rect,
        view: View,
        parent: RecyclerView,
        state: RecyclerView.State
    ) {
        super.getItemOffsets(outRect, view, parent, state)
        outRect.set(0 , lineHeight, 0, 0);
    }
    fun setDrawable(drawable: Drawable) {
        mDivider = drawable
    }

    fun setPaddingHorizontal(padding:Int){
        paddingHorizontal = padding
    }

    fun setLineHeight(height:Int){
        lineHeight = height
    }

    override fun onDraw(c: Canvas, parent: RecyclerView, state: RecyclerView.State) {
        super.onDraw(c, parent, state)
        c.save()
        val count: Int = parent.childCount //获得当前RecyclerView数量

        for (i in 0 until count) {       //遍历全部item View
            val view: View =parent.getChildAt(i)
            val top = view.top //获得这个item View的top位置
            val bottom = view.bottom
            val left = view.left
            val right = view.right
            mDivider.setBounds(left +paddingHorizontal, top , right, top +lineHeight)
            mDivider.draw(c)
        }
        c.restore()
    }
}