package com.at.video.service.ui.service.order.detail

import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.at.common.ImageConfig
import com.at.common.global.Constants
import com.at.common.load

import com.at.video.service.R
import com.at.video.service.entity.FileInfo
import com.at.video.service.entity.OrderDetailMsgInfo
import com.at.video.service.ui.service.emoji.EmojiConversionUtils
import com.at.video.service.ui.service.utils.TimeUtils
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.listener.OnItemChildClickListener
import com.chad.library.adapter.base.listener.OnItemClickListener
import com.chad.library.adapter.base.viewholder.BaseViewHolder

/**
 * @Create_time: 2022/5/9 20:20
 * @Description:
 */

//data class WorkOrderMessageData(
//    val message: OrderDetailMsgInfo,
//    override val itemType: Int = message.msg_type - 1
//): MultiItemEntity
//
//class WorkOrderDetailAdapter: BaseMultiItemQuickAdapter<WorkOrderMessageData, BaseViewHolder>() {
//
//    init {
//        addItemType(0, R.layout.service_item_work_order_left)
//        addItemType(1, R.layout.service_item_work_order_right)
//    }
//
//    override fun convert(holder: BaseViewHolder, item: WorkOrderMessageData) {
//        val adapter = OrderDetailFileAdapter()
//        holder.setText(R.id.tv_service_message,item.message.content)
//        try {
//            val dateTime = DateTime(item.message.created_at!!)
//            val result = dateTime.toCalendar(Locale.getDefault()).timeInMillis
//            val time = DateUtils.format(result,"yyyy-MM-dd HH:mm:ss")
//            holder.setText(R.id.tv_time,time)
//        }catch (e:Exception){
//        }
//        holder.getView<RecyclerView>(R.id.rv_service_file).adapter = adapter
//        adapter.setNewInstance(item.message.appendix as MutableList<FileInfo>?)
//    }
//}

class WorkOrderDetailAdapter:BaseQuickAdapter<OrderDetailMsgInfo,BaseViewHolder>( R.layout.service_item_work_order_left){
    override fun convert(holder: BaseViewHolder, item: OrderDetailMsgInfo) {
        val adapter = OrderDetailFileAdapter()
        if(item.content!!.indexOf("img") == -1){
            holder.getView<ImageView>(R.id.div_image).visibility = View.GONE
            holder.setVisible(R.id.tv_service_message,true)
            val content = item.content!!.replace("<p>","").replace("</p>","")
            val expressionString =
                EmojiConversionUtils.INSTANCE.getExpressionString(context, content)
            holder.setText(R.id.tv_service_message,expressionString.toString())
            try {
                holder.setText(R.id.tv_time,TimeUtils.getTimeStr(item.created_at))
            }catch (e:Exception){
            }
        }else{
            val imgs = item.content.split("src")
            if(imgs.size >1 && imgs[1].split("\"").size>1){
                holder.getView<TextView>(R.id.tv_service_message).visibility = View.GONE
                holder.setVisible(R.id.div_image,true)
                holder.getView<ImageView>(R.id.div_image).load(ImageConfig(imgs[1].split("\"")[1]))
            }
        }

        val defaultAvatar = if(item.msg_type == 1)R.drawable.service_ic_default_header else R.drawable.service_ic_user_default_header
        if(item.msg_type == 2){
            holder.getView<ImageView>(R.id.div_header).load(ImageConfig(Constants.SERVICE_URL+item.visitor_avatar, placeholderId = defaultAvatar, errorId = defaultAvatar))
        }

        holder.getView<RecyclerView>(R.id.rv_service_file).adapter = adapter
        adapter.setNewInstance(item.appendix as MutableList<FileInfo>?)
        adapter.addChildClickViewIds(R.id.iv_download)
        adapter.setOnItemClickListener(onItemClickListenerTemp!!)
        adapter.setOnItemChildClickListener(onChildItemClickListener)
    }

    private var onItemClickListenerTemp:OnItemClickListener? = null
    private var onChildItemClickListener:OnItemChildClickListener?=null

    fun setOnItemClickListenerTemp(childItemClickListener:OnItemClickListener){
        onItemClickListenerTemp = childItemClickListener
    }

    fun setOnChildItemClickListener(childClickListener: OnItemChildClickListener){
        onChildItemClickListener = childClickListener
    }

}