package com.at.video.service.ui.service.utils

import android.content.Context
import android.view.View
import android.view.inputmethod.InputMethodManager

object SoftKeyboardUtils {
    fun closeKeyboard(view: View){
        /**
         * 京东在baseActivity隐藏键盘写的
         * ((InputMethodManager) getSystemService("input_method")).hideSoftInputFromWindow(getWindow().getDecorView().getWindowToken(), 0);
         * android11，有些设备有适配问题，所以直接使用InputMethodManager
         * view.windowInsetsController?.hide(WindowInsets.Type.ime())
         */
        val manager: InputMethodManager = view.context.getSystemService(Context.INPUT_METHOD_SERVICE)
                as InputMethodManager? ?: return
        //view.isFocusable = false
        //view.isFocusableInTouchMode = false
        view.clearFocus()
        manager.hideSoftInputFromWindow(view.windowToken, 0)
    }
}