package com.at.video.service.widget

import android.graphics.drawable.Drawable
import androidx.annotation.StyleRes
import android.content.pm.ActivityInfo
import com.at.video.service.R
import com.at.video.service.widget.loader.ImageLoader

/**
 * @author
 */
enum class ViewerSpec {
    INSTANCE;

    @JvmField
    var position = 0
    @JvmField
    var listData: List<*>? = null
    @JvmField
    var imageLoader: ImageLoader? = null
    @JvmField
    var isShowIndicator = false
    @JvmField
    var placeholderDrawable: Drawable? = null
    @JvmField
    var errorDrawable: Drawable? = null

    @JvmField
    @StyleRes
    var theme = R.style.ImageViewerTheme
    @JvmField
    var orientation = ActivityInfo.SCREEN_ORIENTATION_BEHIND
    fun reset() {
        position = 0
        listData = null
        imageLoader = null
        isShowIndicator = false
        placeholderDrawable = null
        errorDrawable = null
        theme = R.style.ImageViewerTheme
        orientation = ActivityInfo.SCREEN_ORIENTATION_BEHIND
    }
}