package com.melancholy.webview

import android.content.Context
import com.melancholy.utils.AppUtils
import com.melancholy.webview.mainprocess.MainProcessCommandsManager
import com.melancholy.webview.webviewprocess.WebViewProcessCommandDispatcher

/**
 * @Create_time: 2019/10/16 11:52
 * @Description: WebView初始化
 */
object WebViewInit {

    //可以延时初始化 或者多线程初始化
    fun init(context: Context) {
        if(AppUtils.isMainProcess(context)) {
            //当是主进程的时候去初始化WebView主进程
            MainProcessCommandsManager.init(context)
        } else if(AppUtils.getCurrentProcessName(context) == "${context.packageName}:tools") {
            //当是tools进程就去初始化WebView进程
            PreloadWebView.init(context)
            WebViewProcessCommandDispatcher.init(context)
        }
    }
}