package com.video.module_widget.api // ktlint-disable package-name

import com.video.module_widget.entity.BaseResponse
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.POST
import retrofit2.http.Query
import retrofit2.http.Url

interface CommonApiService {

    // 收藏
    @POST("v1/user/collect_record/create")
    suspend fun collect(@Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse

    // 删除收藏
    @POST("v1/user/collect_record/delete")
    suspend fun deleteCollect(@Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse

    // 点赞
    @POST("v1/user/star_record/create")
    suspend fun star(@Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse

    // 删除点赞
    @POST("v1/user/star_record/delete")
    suspend fun deleteStar(@Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse

    // 添加观看历史
    @POST("v1/user/watch_history/create_or_update")
    suspend fun watchHistory(@Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse

    // 获取观看进度
    @GET("v1/user/watch_history")
    suspend fun getWatchProgress(@Query("resource_id") params: String)

    // 删除观看历史
    @POST("v1/user/watch_history/delete")
    suspend fun deleteHis(@Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse

    @POST("v1/cms/update_popularity")
    suspend fun shareRes(@Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse

    @POST
    suspend fun dataReport(@Url url: String, @Body map: @JvmSuppressWildcards Map<String, Any>): BaseResponse
}
