package com.video.module_widget.binder

import android.graphics.Color
import android.graphics.Typeface
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import android.widget.LinearLayout
import android.widget.TextView
import androidx.cardview.widget.CardView
import androidx.core.view.setMargins
import androidx.recyclerview.widget.GridLayoutManager
import com.at.common.global.Constants
import com.at.common.utils.JsonUtils
import com.chad.library.adapter.base.binder.BaseItemBinder
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.melancholy.router.api.launcher.Router
import com.melancholy.utils.AppInstance
import com.melancholy.utils.DensityUtils
import com.video.module_widget.R
import com.video.module_widget.entity.AdvertisingBean
import com.video.module_widget.entity.WordStyle
import com.video.module_widget.utils.toRgb

/**
 * @Create_time: 2022/6/23 19:44
 * @Description:
 */

class GapLineBinder(private val bgColor:Int = Color.WHITE): BaseItemBinder<GapLineBinder.Data, BaseViewHolder>(){
    private val mPadding: Int = AppInstance.getApplication().resources
        .getDimensionPixelSize(com.at.common.R.dimen.dp_16)
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder {
        return BaseViewHolder(
            LayoutInflater.from(parent.context)
            .inflate(R.layout.common_gap_line_view, parent, false))
    }

    override fun convert(holder: BaseViewHolder, data: Data) {
       val root  = holder.itemView as LinearLayout
        root.setBackgroundColor(bgColor)
    }

    data class Data(val color: String)
}