package com.video.module_widget.dialog

import android.os.Bundle
import android.view.*
import com.at.common.binding.BaseBindingDialogFragment
import com.at.common.utils.ToastUtils
import com.melancholy.utils.ClipboardUtils
import com.video.module_widget.R
import com.video.module_widget.constants.GlobalConsts
import com.video.module_widget.databinding.PlayerShareDialogBinding

/**
 *@author luoyi
 *@name 分享弹窗
 *@desciption
 *@since 2023/1/9 下午1:14
 *@version 1.0.0
 **/
class ShareDialog : BaseBindingDialogFragment<PlayerShareDialogBinding>() {
    override fun initialize(view: View, savedInstanceState: Bundle?) {
        requireBinding().apply {
            tvCanceShare.setOnClickListener {
                dismissAllowingStateLoss()
            }
            clCopyShareAddress.setOnClickListener {
                if (activity != null && !GlobalConsts.SHARE_URL.isNullOrEmpty()) {
                    ClipboardUtils.copyText(activity!!.applicationContext, GlobalConsts.SHARE_URL!!)
                    ToastUtils.show("复制成功")
                    dismissAllowingStateLoss()
                } else {
                    ToastUtils.show("配置信息有误，请稍后再试！")
                }

            }
        }
    }

    override fun loadData() {
    }

    override fun getCustomTheme(): Int = R.style.ShareDialogTheme

    override fun getWidth(): Int = WindowManager.LayoutParams.MATCH_PARENT

    override fun getHeight(): Int = WindowManager.LayoutParams.WRAP_CONTENT

    override fun getGravity(): Int {
        return Gravity.BOTTOM
    }

    override fun createViewBinding(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): PlayerShareDialogBinding {
        return PlayerShareDialogBinding.inflate(inflater, container, false)
    }
}