package com.video.module_widget.entity


import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class AdvertisingBean(
    val id: String?,
    val library_id: String?,
    val type: Int,
    val image_type: Int?, // 图文类型 1-文件 2-图片-url 3-文字
    val image_url:String?,// 图片地址或文字数据
    val name: String?,
    val jump_addr: String?,
    val show_position: String?,
    val word_style:String?, // 文字风格数据
    val order: Int?,
    var status: Int?,
    val show_time: Int = 0,
    val created_at: String?,
    val updated_at: String?,
    val addr:String?
): Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readString() ?: "",
        parcel.readString()?:"",
        parcel.readInt(),
        parcel.readInt()?:1,
        parcel.readString()?:"",
        parcel.readString()?:"",
        parcel.readString()?:"",
        parcel.readString() ?: "",
        parcel.readString() ?: "",
        parcel.readInt(),
        parcel.readInt(),
        parcel.readInt(),
        parcel.readString() ?: "",
        parcel.readString() ?: "",
        parcel.readString() ?: ""
    ) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(id)
        parcel.writeString(library_id)
        parcel.writeInt(type)
        parcel.writeInt(image_type?:1)
        parcel.writeString(image_url)
        parcel.writeString(name)
        parcel.writeString(jump_addr)
        parcel.writeString(show_position)
        parcel.writeString(word_style)
        parcel.writeInt(order?:0)
        parcel.writeInt(status?:1)
        parcel.writeInt(show_time)
        parcel.writeString(created_at)
        parcel.writeString(updated_at)
        parcel.writeString(addr)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<AdvertisingInfo> {
        override fun createFromParcel(parcel: Parcel): AdvertisingInfo {
            return AdvertisingInfo(parcel)
        }

        override fun newArray(size: Int): Array<AdvertisingInfo?> {
            return arrayOfNulls(size)
        }
    }
}