package com.video.module_widget.entity

import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class DataReport(
//    val app_id:String,
//    val webmaster_id:String,
    val source: Int = 1,
    val app_version: String? = null,
    val report_time: Long = 0L,
    val device_id: String? = null,
    val device_brand: String? = null,
    val device_model: String? = null,
    val device_system: String = "Android",
    val system_version: String ? = null,
    val screen_resolution: String ? = null,
    val sim1: String ? = null,
    val sim2: String ? = null,
    val country: String ? = null,
    val province: String ? = null,
    val city: String? = null,
    val district: String? = null,
    val longitude: String? = null,
    val latitude: String? = null,
    // // 网络状态(0:未知, 1:移动网络, 2:WIFI, 3:无网络)
    val network_status: Int = 0,
    // 网络运营商(0:未知, 1:电信, 2:联通, 3:移动)
    val network_operator: Int = 0,
    val is_first: Int ? = null // 1是，2 否
)

// 数据上报实体
@JsonClass(generateAdapter = true)
data class DataRecordBean(
    val log_record: LogRecord? = null,
    val startup_record: StartUpRecord? = null,
    val active_record: ActiveRecord? = null,
    val play_record: PlayRecord? = null,
    val read_record: PlayRecord? = null
)

@JsonClass(generateAdapter = true)
data class LogRecord(
    val user_id: String? = null, // 【非必传】用户id
    val webmaster_id: String?, // 非必传】站长id
    val app_id: String?, // 必传】应用id
    val source: Int = 1,
    val app_version: String?,
    var content: String? = null, // 【必传】日志内容
    val device_id: String?,
    val device_model: String?,
    val device_system: String?,
    val device_brand: String?,
    val sdk_version: String?,
    val system_version: String?,
    val report_time: Long = System.currentTimeMillis()
)

@JsonClass(generateAdapter = true)
data class StartUpRecord(
    val webmaster_id: String?, // 非必传】站长id
    val app_id: String?, // 必传】应用id
    val source: Int = 1,
    val app_version: String?,
    val device_id: String?,
    val device_model: String?,
    val device_system: String?,
    val device_brand: String?,
    val system_version: String?,
    val screen_resolution: String?,
    val sim1: String?,
    val sim2: String?,
    val ip: String?,
    val country: String?,
    val province: String?,
    val city: String?,
    val district: String?,
    val longitude: String?,
    val latitude: String?,
    val network_status: Int = 0, // 0: 未知 1: 移动网络 2: WIFI 3: 无网络
    val network_operator: Int = 0, // 0: 未知 1: 中国电信 2: 中国联通 3: 中国移动
    val is_first: Int = 0
)

@JsonClass(generateAdapter = true)
data class ActiveRecord(
    val device_id: String?,
    val app_id: String?, // 必传】应用id
    val webmaster_id: String?, // 非必传】站长id
    val source: Int = 1,
    val app_version: String?,
    val device_model: String?,
    val device_system: String?,
    val device_brand: String?,
    val system_version: String?,
    val screen_resolution: String?,
    val sim1: String?,
    val sim2: String?,
    val ip: String?,
    val country: String?,
    val province: String?,
    val city: String?,
    val district: String?,
    val longitude: String?,
    val latitude: String?,
    val network_status: Int = 0, // 0: 未知 1: 移动网络 2: WIFI 3: 无网络
    val network_operator: Int = 0, // 0: 未知 1: 中国电信 2: 中国联通 3: 中国移动
    val is_first: Int = 0,
    var user_id: String? = null
)

@JsonClass(generateAdapter = true)
data class PlayRecord(
    var resource_id: String? = null, // 必传 资源ID
    var resource_type: Int? = null, // 阅读的时候必传 资源类型
    val device_id: String?,
    val app_id: String?, // 必传】应用id
    val webmaster_id: String?, // 非必传】站长id
    val source: Int = 1,
    val app_version: String?,
    val device_model: String?,
    val device_system: String?,
    val device_brand: String?,
    val system_version: String?,
    val screen_resolution: String?,
    val sim1: String?,
    val sim2: String?,
    val ip: String?,
    val country: String?,
    val province: String?,
    val city: String?,
    val district: String?,
    val longitude: String?,
    val latitude: String?,
    val network_status: Int = 0, // 0: 未知 1: 移动网络 2: WIFI 3: 无网络
    val network_operator: Int = 0, // 0: 未知 1: 中国电信 2: 中国联通 3: 中国移动
    var user_id: String? = null
)