package com.video.module_widget.entity

import com.squareup.moshi.JsonClass

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/7/21 下午4:47
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/7/21 下午4:47
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
@JsonClass(generateAdapter = true)
data class HomeStyle(
    val background:String?=null,
    val content:List<Content?>? = null,
    val playerBeforeAdv:Adv? = null,
    val playerPauseAdv:Adv? = null,
    val footerBar:FooterBar? = null
)
@JsonClass(generateAdapter = true)
data class Content(
    val type:String?=null,
    val config:Config? = null
)

@JsonClass(generateAdapter = true)
data class Adv(
    val duration:Int = 3,
    val source: DataSource? = null,
    val radius:Int = 0,
    val width:Int = 160,
    val height:Int = 120,
    val show:Boolean = false
)

@JsonClass(generateAdapter = true)
data class Config(
    val background:String? = null,
    val fill:String? = null,
    val titleColor:String? = null,
    val cols:Int = 1,
    val style:Int = 1,
    val height:Int = 1,
    val duration:Int = 3000,
    val radius:Int = 1,
    val tagStyle:Int = 1,
    val title:TextConfig? = null,
    val layout:Layout? = null,
    val dataSource: DataSource? = null,
    val border:BorderConfig? = null,
    val tag:Background? = null,
    val text:ButtonTextConfig? = null,
    val collection:ButtonStyle? = null,
    val read:ButtonStyle? = null,
    val moreButton:MoreButton? = null,
    val enable:Boolean = true,
    val color:String? = null,
    val maxLine:Int = Int.MAX_VALUE,
    val indicator:IndicatorConfig? = null,
    val width:Int = 0,
    val selectedBorderColor:String? = null,
    val selectedBackground:String? = null,
    val selectTextColor:String? = null,

)

@JsonClass(generateAdapter = true)
data class MoreButton(
    val enable:Boolean,
    val style:Int
)

@JsonClass(generateAdapter = true)
data class ButtonStyle(
    val fill:String?,
    val color:String?
)

@JsonClass(generateAdapter = true)
data class Text(
    val color:String? = null,
    val size:Int = 12,
    val selectedColor:String ? = null,
    val selectedSize:Int = 14,
    val content:String = ""
)

@JsonClass(generateAdapter = true)
data class Background(
    val color:String? = null,
    val selected:String? = null
)

@JsonClass(generateAdapter = true)
data class Layout(val style:Int = 1,val limit:Int = 12)


// newest: 最新 hottest: 最热 recommend:推荐  album:专辑  : 分类
@JsonClass(generateAdapter = true)
data class DataSource(val type:String? = null,val id:String? = null)

@JsonClass(generateAdapter = true)
data class Exchange(val enable:Boolean = true,val style:Int = 1)
