package com.video.module_widget.entity.home

import com.squareup.moshi.JsonClass
import com.video.module_widget.entity.*

@JsonClass(generateAdapter = true)
data class HomeTopBarConfig(
    val topBar:List<TopBarConfig> = arrayListOf(),
    val noticeBar:List<NoticeBarContent> = arrayListOf(),
    val dialogAdv: Adv? = null,
    val bottomFloatAdv:Adv? = null
)

@JsonClass(generateAdapter = true)
data class TopBarConfig(
    val type:String = "",
    val content:List<HomeTopContent>? = null
)

@JsonClass(generateAdapter = true)
data class HomeTopContent(
    val type:String = "",
    val config:ContentConfig? = null
)

@JsonClass(generateAdapter = true)
data class ContentConfig(
    val logo: Logo? = null,
    val search:SearchBarConfig? = null,
    val collection:CollectionConfig? = null,

    val indicator:IndicatorConfig? = null,
    val background:String? = null,
    val text:ButtonTextConfig? = null
)

@JsonClass(generateAdapter = true)
data class SearchBarConfig(
    val fill:String?=null,
    val placeholder:String? = null,
    val color:String? = null,
    val iconColor:String? = null,
    val align:String? = null,
    val border: BorderConfig? = null,
)

@JsonClass(generateAdapter = true)
data class NoticeBarContent(
    val type:String = "",
    val config:NoticeBarConfig? = null
)
@JsonClass(generateAdapter = true)
data class NoticeBarConfig(
    val background:String? = null,
    val style:Int = 1,
    val height:Int = 0,
    val text:ButtonTextConfig,
    val duration:Long = 0L,
    val iconStyle:Int = 1,
    val closeStyle:Int = 1
    )