package com.video.module_widget.utils

import android.annotation.SuppressLint
import android.content.Context.LOCATION_SERVICE
import android.location.*
import android.os.Bundle
import android.util.Log
import com.melancholy.utils.AppInstance
import java.lang.String
import java.util.*
import kotlin.Exception

object LocationManagerUtils {
    var locationManager: LocationManager? = null
    var longitude: kotlin.String? = null
    var latitude: kotlin.String? = null
    var address_details: kotlin.String? = null
    var city: kotlin.String? = null
    var provice: kotlin.String? = null
    var country: kotlin.String? = null
    fun getNowLocation() {
        locationManager = AppInstance.getApplication().getSystemService(LOCATION_SERVICE) as LocationManager
        val location = getLastKnownLocation(locationManager!!)
        if (location != null) {
            longitude = String.valueOf(location.longitude)
            latitude = String.valueOf(location.latitude)
            val geocoder = Geocoder(AppInstance.getApplication(), Locale.getDefault())
            try {
                val addresses: List<Address>? = geocoder.getFromLocation(
                    java.lang.Double.valueOf(latitude),
                    java.lang.Double.valueOf(longitude),
                    1
                )
                if (addresses != null && addresses.isNotEmpty()) {
                    val address: Address = addresses[0]
                    provice = address.adminArea
                    city = address.locality
                    country = address.countryName
                    address_details = address.getAddressLine(0)
                    Log.e("LOCATION", "getNowLocation: $latitude,$longitude")
                }
            } catch (e: Exception) {
                // 可能会报异常，可能是因为手机不支持Google定位导致
//                e.printStackTrace()
            }
        }
    }

    @SuppressLint("MissingPermission")
    fun getLastKnownLocation(locationManager: LocationManager): Location? {
        val criteria = Criteria()
        criteria.accuracy = Criteria.ACCURACY_COARSE
        criteria.isAltitudeRequired = false
        criteria.isBearingRequired = false
        criteria.isCostAllowed = true
        criteria.powerRequirement = Criteria.POWER_LOW
        val providers = locationManager.getBestProvider(criteria, true)
        locationManager.requestLocationUpdates(
            LocationManager.GPS_PROVIDER,
            2000,
            0f,
            object : LocationListener {
                override fun onLocationChanged(location: Location) {
                    Log.e(
                        "LOCATION",
                        "onLocationChanged: ${location.longitude},${location.latitude}"
                    )
                }

                override fun onStatusChanged(provider: kotlin.String?, status: Int, extras: Bundle?) {
                }

                override fun onProviderEnabled(provider: kotlin.String) {
                }

                override fun onProviderDisabled(provider: kotlin.String) {
                }
            }
        )
        return providers?.let { locationManager.getLastKnownLocation(it) }
    }
}
