package com.video.module_widget.utils

import android.content.Context
import android.graphics.Color

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/7/22 上午10:01
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/7/22 上午10:01
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */


fun String.toColor():Int = Color.parseColor(this)

fun String.toArgb(alpha:Double = -1.0):Int {
    if(this.isEmpty()) return Color.BLACK
    if(this.contains("#")){
        return toColor()
    }else{
        val colorStr = this.replace("rgba(","").replace(")","").replace(" ","")
        val colors = colorStr.split(",")
        var a = if(alpha != -1.0) 255 * alpha else 255
        if(colors.isEmpty()){
            return Color.argb(a.toInt(),255,255,255)
        }
        if(colors.size <4){
            return  Color.argb(a.toInt(),colors[0].toInt(),colors[1].toInt(),colors[2].toInt())
        }
        a = if(alpha != -1.0) 255 * alpha else (colors[3].toDouble() * 255)
        return Color.argb(a.toInt(),colors[0].toInt(),colors[1].toInt(),colors[2].toInt())
    }
}

fun String.toRgb():Int {
    if(this.isEmpty()) return Color.BLACK
    if(this.contains("#")){
        return  toColor()
    }else{
        if(this.indexOf("rgba") !=-1) return toArgb()
        val colorStr = this.replace("rgb(","").replace(")","").replace("\\s".toRegex(),"")
        val colors = colorStr.split(",")
        if(colors.isEmpty()){
            return Color.argb(255,255,255,255)
        }
        return Color.argb(255,colors[0].toInt(),colors[1].toInt(),colors[2].toInt())
    }
}

fun Context.toColor(color:Int):Int = resources.getColor(color)