package com.video.module_widget.utils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

/**
 * @author user1
 * @time 20-5-20  上午11:06
 * @describe tracker处理工具
 */
public class TrackersUtil {

    final static String TAG = "tracker_utls";

    private final static List<String> mTrackers = new ArrayList();


    /**
     * 添加tracker服务器地址
     *
     * @param tracks 服务器返回track 服务器地址
     */
    public static void addTracker(List<String> tracks) {
        mTrackers.clear();
        mTrackers.addAll(tracks);
    }

    /**
     * 拼接磁力链
     *
     * @param url 磁力地址
     * @return
     */
    public static String spliceTracker(String url) {

        if (mTrackers.isEmpty()) {
            return url;
        }
        StringBuilder sbUrlEncode = new StringBuilder(url);
        for (String tracker : mTrackers) {
            if (tracker == null || tracker.isEmpty()) {
                continue;
            }
            sbUrlEncode.append("&tr=");
            try {
                sbUrlEncode.append(URLEncoder.encode(tracker, "utf-8"));
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }

        return sbUrlEncode.toString();
    }


}
