package com.video.module_widget.widget

import android.content.Context
import android.util.Log
import android.view.MotionEvent
import android.view.ViewConfiguration
import androidx.viewpager2.widget.ViewPager2
import com.video.module_widget.binder.BannerBinder
import com.video.module_widget.entity.AdvertisingBean
import com.youth.banner.Banner
import com.youth.banner.adapter.BannerImageAdapter
import kotlin.math.abs

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/7/7 上午11:01
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/7/7 上午11:01
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
class CustomBanner(context: Context):Banner<AdvertisingBean, BannerBinder.BannerRadiusImageAdapter<AdvertisingBean>>(context) {
    private var downX: Float = 0f
    private var downY: Float = 0f
    private var isDragged = false
    private val touchSlop = ViewConfiguration.get(context).scaledTouchSlop
    override fun onInterceptTouchEvent(ev: MotionEvent): Boolean {
        val parentView = parent.parent.parent.parent.parent.parent as? ViewPager2
        when (ev.action) {
            MotionEvent.ACTION_DOWN -> {
                downX = ev.x
                downY = ev.y
                isDragged = false
                parentView?.let {
                    requestDisallowInterceptTouchEvent(true)
                }
            }
            MotionEvent.ACTION_MOVE -> {
                if (!isDragged) {
                    val dx = abs(ev.x - downX)
                    val dy = abs(ev.y - downY)
                    isDragged =  dx - dy >0
                    Log.e("vertical","dx:${dx},dy:${dy},isDragged:${isDragged}")
//                        parent.requestDisallowInterceptTouchEvent(false)
                    parentView?.let {
                        it.isUserInputEnabled = !isDragged
                        requestDisallowInterceptTouchEvent(isDragged)
                    }
                }
            }
            MotionEvent.ACTION_UP, MotionEvent.ACTION_CANCEL -> {
                isDragged = false
                parentView?.let {
                    it.isUserInputEnabled = false
                    requestDisallowInterceptTouchEvent(false)
                }
            }
        }
        return super.onInterceptTouchEvent(ev)
    }
}