package com.video.module_widget.widget

import android.content.Context
import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.Rect
import android.util.Log
import android.view.View
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.melancholy.utils.AppInstance

/**
 * @Create_time: 2022/5/26 11:10
 * @Description: 间隔分割线
 */

class HorizontalIntervalDecoration(): RecyclerView.ItemDecoration() {

    private val mPadding: Int = AppInstance.getApplication().resources
        .getDimensionPixelSize(com.at.common.R.dimen.dp_16)
    override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView,
                                state: RecyclerView.State) {
        val itemPosition = parent.getChildAdapterPosition(view)
       val count = parent.adapter!!.itemCount
        if(itemPosition == 0) {
            outRect.set(mPadding, mPadding, mPadding, 0)
        }  else{
            outRect.set(0, mPadding, mPadding, 0)
        }
    }
}