package com.video.module_widget.widget

import android.content.Context
import android.graphics.drawable.GradientDrawable
import android.util.AttributeSet
import androidx.appcompat.widget.AppCompatButton
import com.melancholy.widget.helper.IViewBackgroundHelper
import com.melancholy.widget.helper.ViewBackgroundHelper
import com.video.module_widget.utils.toColor

/**
 *
 * @Description: java类作用描述
 * @CreateDate: 2022/8/4 下午3:09
 * @UpdateUser: 更新者
 * @UpdateDate: 2022/8/4 下午3:09
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
open class ShapeButtonExt @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null,
                                                 defStyleAttr: Int = android.R.attr.buttonStyle): AppCompatButton(context, attrs, defStyleAttr),
    IViewBackgroundHelper {

    private val mHelper: ViewBackgroundHelperExt = ViewBackgroundHelperExt(this, context, attrs,
        defStyleAttr, 0)

    override fun setShape(shape: Int) {
        mHelper.setShape(shape)
    }

    override fun getShape(): Int = mHelper.getShape()

    override fun setBackgroundColor(color:Int){
        mHelper.setShapeSolidColor(color)
        mHelper.setShapeStartColor(color)
        mHelper.setShapeEndColor(color)
    }


     fun setGradientColor(startColor:Int,endColor:Int){
         mHelper.setShapeStartColor(startColor)
         mHelper.setShapeEndColor(endColor)
    }
    fun reBuilder(){
        mHelper.createDrawable(this)
    }

    override fun setShapeWidth(width: Int) {
        mHelper.setShapeWidth(width)
    }

    override fun getShapeWidth(): Int = mHelper.getShapeWidth()

    override fun setShapeHeight(height: Int) {
        mHelper.setShapeHeight(height)
    }

    override fun getShapeHeight(): Int = mHelper.getShapeHeight()

    override fun setShapeSolidColor(color: Int) {
        mHelper.setShapeSolidColor(color)
    }

    override fun getShapeSolidColor(): Int = mHelper.getShapeSolidColor()

    override fun setShapeSolidPressedColor(color: Int) {
        mHelper.setShapeSolidPressedColor(color)
    }

    override fun getShapeSolidPressedColor(): Int = mHelper.getShapeSolidPressedColor()

    override fun setShapeSolidCheckedColor(color: Int) {
        mHelper.setShapeSolidCheckedColor(color)
    }

    override fun getShapeSolidCheckedColor(): Int = mHelper.getShapeSolidCheckedColor()

    override fun setShapeSolidDisabledColor(color: Int) {
        mHelper.setShapeSolidDisabledColor(color)
    }

    override fun getShapeSolidDisabledColor(): Int = mHelper.getShapeSolidDisabledColor()

    override fun setShapeSolidFocusedColor(color: Int) {
        mHelper.setShapeSolidFocusedColor(color)
    }

    override fun getShapeSolidFocusedColor(): Int = mHelper.getShapeSolidFocusedColor()

    override fun setShapeSolidSelectedColor(color: Int) {
        mHelper.setShapeSolidSelectedColor(color)
    }

    override fun getShapeSolidSelectedColor(): Int = mHelper.getShapeSolidSelectedColor()

    override fun setShapeRadius(radius: Int) {
        mHelper.setShapeRadius(radius)
    }

    override fun setShapeTopLeftRadius(radius: Int) {
        mHelper.setShapeTopLeftRadius(radius)
    }

    override fun getShapeTopLeftRadius(): Int = mHelper.getShapeTopLeftRadius()

    override fun setShapeTopRightRadius(radius: Int) {
        mHelper.setShapeTopRightRadius(radius)
    }

    override fun getShapeTopRightRadius(): Int = mHelper.getShapeTopRightRadius()

    override fun setShapeBottomLeftRadius(radius: Int) {
        mHelper.setShapeBottomLeftRadius(radius)
    }

    override fun getShapeBottomLeftRadius(): Int = mHelper.getShapeBottomLeftRadius()

    override fun setShapeBottomRightRadius(radius: Int) {
        mHelper.setShapeBottomRightRadius(radius)
    }

    override fun getShapeBottomRightRadius(): Int = mHelper.getShapeBottomRightRadius()

    override fun setShapeStartColor(color: Int) {
        mHelper.setShapeStartColor(color)
    }

    override fun getShapeStartColor(): Int = mHelper.getShapeStartColor()

    override fun setShapeCenterColor(color: Int) {
        mHelper.setShapeCenterColor(color)
    }

    override fun getShapeCenterColor(): Int = mHelper.getShapeCenterColor()

    override fun setShapeEndColor(color: Int) {
        mHelper.setShapeEndColor(color)
    }

    override fun getShapeEndColor(): Int = mHelper.getShapeEndColor()

    override fun isShapeGradientColor(): Boolean = mHelper.isShapeGradientColor()

    override fun clearShapeGradientColor() {
        mHelper.clearShapeGradientColor()
    }

    override fun setShapeUseLevel(useLevel: Boolean) {
        mHelper.setShapeUseLevel(useLevel)
    }

    override fun isShapeUseLevel(): Boolean = mHelper.isShapeUseLevel()

    override fun setShapeAngle(angle: Int) {
        mHelper.setShapeAngle(angle)
    }

    override fun getShapeAngle(): Int = mHelper.getShapeAngle()

    override fun setShapeGradientType(type: Int) {
        mHelper.setShapeGradientType(type)
    }

    override fun getShapeGradientType(): Int = mHelper.getShapeGradientType()

    override fun setShapeCenterX(x: Float) {
        mHelper.setShapeCenterX(x)
    }

    override fun getShapeCenterX(): Float = mHelper.getShapeCenterX()

    override fun setShapeCenterY(y: Float) {
        mHelper.setShapeCenterY(y)
    }

    override fun getShapeCenterY(): Float = mHelper.getShapeCenterY()

    override fun setShapeGradientRadius(radius: Int) {
        mHelper.setShapeGradientRadius(radius)
    }

    override fun getShapeGradientRadius(): Int = mHelper.getShapeGradientRadius()

    override fun setShapeStrokeColor(color: Int) {
        mHelper.setShapeStrokeColor(color)
    }

    override fun getShapeStrokeColor(): Int = mHelper.getShapeStrokeColor()

    override fun setShapeStrokePressedColor(color: Int) {
        mHelper.setShapeStrokePressedColor(color)
    }

    override fun getShapeStrokePressedColor(): Int = mHelper.getShapeStrokePressedColor()

    override fun setShapeStrokeCheckedColor(color: Int) {
        mHelper.setShapeStrokeCheckedColor(color)
    }

    override fun getShapeStrokeCheckedColor(): Int = mHelper.getShapeStrokeCheckedColor()

    override fun setShapeStrokeDisabledColor(color: Int) {
        mHelper.setShapeStrokeDisabledColor(color)
    }

    override fun getShapeStrokeDisabledColor(): Int = mHelper.getShapeStrokeDisabledColor()

    override fun setShapeStrokeFocusedColor(color: Int) {
        mHelper.setShapeStrokeFocusedColor(color)
    }

    override fun getShapeStrokeFocusedColor(): Int = mHelper.getShapeStrokeFocusedColor()

    override fun setShapeStrokeSelectedColor(color: Int) {
        mHelper.setShapeStrokeSelectedColor(color)
    }

    override fun getShapeStrokeSelectedColor(): Int = mHelper.getShapeStrokeSelectedColor()

    override fun setShapeStrokeWidth(width: Int) {
        mHelper.setShapeStrokeWidth(width)
    }

    override fun getShapeStrokeWidth(): Int = mHelper.getShapeStrokeWidth()

    override fun setShapeDashWidth(width: Int) {
        mHelper.setShapeDashWidth(width)
    }

    override fun getShapeDashWidth(): Int = mHelper.getShapeDashWidth()

    override fun setShapeDashGap(gap: Int) {
        mHelper.setShapeDashGap(gap)
    }

    override fun getShapeDashGap(): Int = mHelper.getShapeDashGap()

    override fun setShapeInnerRadius(radius: Int) {
        mHelper.setShapeInnerRadius(radius)
    }

    override fun getShapeInnerRadius(): Int = mHelper.getShapeInnerRadius()

    override fun setShapeInnerRadiusRatio(ratio: Float) {
        mHelper.setShapeInnerRadiusRatio(ratio)
    }

    override fun getShapeInnerRadiusRatio(): Float = mHelper.getShapeInnerRadiusRatio()

    override fun setShapeThickness(size: Int) {
        mHelper.setShapeThickness(size)
    }

    override fun getShapeThickness(): Int = mHelper.getShapeThickness()

    override fun setShapeThicknessRatio(ratio: Float) {
        mHelper.setShapeThicknessRatio(ratio)
    }

    override fun isShapeShadowEnable(): Boolean = mHelper.isShapeShadowEnable()

    override fun getShapeThicknessRatio(): Float = mHelper.getShapeThicknessRatio()

    override fun setShapeShadowSize(size: Int) {
        mHelper.setShapeShadowSize(size)
    }

    override fun getShapeShadowSize(): Int = mHelper.getShapeShadowSize()

    override fun setShapeShadowColor(color: Int) {
        mHelper.setShapeShadowColor(color)
    }

    override fun getShapeShadowColor(): Int = mHelper.getShapeShadowColor()

    override fun setShapeShadowOffsetX(offsetX: Int) {
        mHelper.setShapeShadowOffsetX(offsetX)
    }

    override fun getShapeShadowOffsetX(): Int = mHelper.getShapeShadowOffsetX()

    override fun setShapeShadowOffsetY(offsetY: Int) {
        mHelper.setShapeShadowOffsetY(offsetY)
    }

    override fun getShapeShadowOffsetY(): Int = mHelper.getShapeShadowOffsetY()
}