package com.video.module_widget.widget

import android.content.Context
import android.os.Build
import android.util.AttributeSet
import android.widget.LinearLayout
import androidx.annotation.FontRes
import androidx.annotation.RequiresApi
import androidx.constraintlayout.widget.ConstraintLayout
import com.melancholy.widget.helper.ViewBackgroundHelper
import com.video.module_widget.utils.getDp
import com.video.module_widget.utils.toColor

/**
 * @Create_time: 2021/8/30 19:34
 * @Author: wr
 * @Description:
 */
open class ShapeConstraintLayoutExt @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0, defStyleRes:Int = 0): ConstraintLayout(context, attrs, defStyleAttr,defStyleRes) {

    private val mHelper: ViewBackgroundHelperExt = ViewBackgroundHelperExt(this, context, attrs,
        defStyleAttr, 0)

      fun setShape(shape: Int) {
        mHelper.setShape(shape)
    }

    override fun setBackgroundColor(color:Int){
        mHelper.setShapeSolidColor(color)
        mHelper.setShapeStartColor(color)
        mHelper.setShapeEndColor(color)
    }

    fun setShapeGradientColor(startColor:Int,endColor:Int){
        mHelper.setShapeStartColor(startColor)
        mHelper.setShapeEndColor(endColor)
    }

    fun setShapeShadowColorAndSize(color:Int,size:Int = 10){
        mHelper.setShapeShadowColor(color)
        mHelper.setShapeShadowSize(size)
    }

    fun setBorderRadius(radius:Int){
        mHelper.setShapeRadius(context.getDp(radius).toInt())
    }

    fun setBorderColor(color:Int){
        mHelper.setShapeStrokeColor(color)
    }

    fun setBorderWidth(width:Int){
        mHelper.setShapeStrokeWidth(context.getDp(width).toInt())
    }

    fun reBuilder(){
        mHelper.createDrawable(this)
    }

}